C  --------------------------------------------------------------
C (C) COPYRIGHT 1994, 1996 University of Chicago
C   
C   THIS PROGRAM DISCLOSES MATERIAL PROTECTABLE UNDER COPYRIGHT
C   LAWS OF THE UNITED STATES. USE IS PERMITTED WITHOUT FEE FOR
C   EDUCATION AND NON-PROFIT RESEARCH PURPOSES SUBJECT TO THE
C   TERMS OF A LICENSE DISTRIBUTED WITH THE ADIFOR 2.0 SOFTWARE
C   AND AVAILABLE AT:
C   http://www.mcs.anl.gov/autodiff/adifor_license.html, or
C   http://www.cs.rice.edu/~adifor/AdiforPublicLicense.html.
C   ANY ENTITY DESIRING PERMISSION TO INCORPORATE THIS SOFTWARE
C   OR A WORK BASED ON THE SOFTWARE INTO COMMERCIAL PRODUCTS OR
C   OTHERWISE USE IT FOR COMMERCIAL PURPOSES SHOULD CONTACT:
C   
C   Paul Hovland, Mathematics and Computer Science Division,
C   Argonne National Laboratory, 9700 S. Cass Avenue, Argonne IL
C   60439, hovland@mcs.anl.gov.
C   
C   Alan Carle, Center for Research on Parallel Computation, Rice
C   University MS 41, 6100 Main Street, Houston, TX 77005,
C   carle@cs.rice.edu.
C  --------------------------------------------------------------
C




























      subroutine ehbsct
     +(type,
     +x,y,z,
     +fx,fy,fxx,fxy,fyy
     +)

      integer type
      COMPLEX x,y
C     function result
      COMPLEX z
      COMPLEX fx,fy,fxx,fxy,fyy





C     These next two are just for the power operator

C     This is a scratch variable used to make real and complex 
C     power look the same.
      REAL yreal

      COMPLEX InfVal, NoLimit, TieVal, JumpVal
      COMPLEX NaNval

      COMPLEX zero, onehalf

      parameter (zero = 0.0d0)
      parameter (onehalf = 0.5d0)

      parameter (InfVal = zero)
      parameter (NoLimit = zero)
      parameter (TieVal = onehalf)
      parameter (JumpVal = zero)

C     These are new exceptional values.

      parameter (NaNval = zero)


      integer FUNC_AINT, FUNC_ANINT, FUNC_DNINT, FUNC_ABS, FUNC_MOD
      integer FUNC_SIGN, FUNC_DIM, FUNC_MAX, FUNC_MIN
      integer FUNC_SQRT, FUNC_SQRT4CABS
      integer FUNC_POWERBASE, FUNC_POWEREXP, FUNC_POWERBOTH
      integer FUNC_ASIN, FUNC_ACOS

      parameter (FUNC_AINT = 1)
      parameter (FUNC_ANINT = 2)
      parameter (FUNC_DNINT = 2)
      parameter (FUNC_ABS = 3)
      parameter (FUNC_MOD = 4)      
      parameter (FUNC_SIGN = 5)
      parameter (FUNC_DIM = 6)
      parameter (FUNC_MAX = 7)
      parameter (FUNC_MIN = 8)
      parameter (FUNC_SQRT = 9)
      parameter (FUNC_POWERBASE = 10)      
      parameter (FUNC_POWEREXP = 11)      
      parameter (FUNC_POWERBOTH = 12)      
      parameter (FUNC_ASIN = 13)
      parameter (FUNC_ACOS = 14)
      parameter (FUNC_SQRT4CABS = 15)

      integer MAX_FN
      parameter (MAX_FN = FUNC_SQRT4CABS)

      integer ERR_AINT, ERR_ANINT, ERR_DNINT
      integer ERR_ABS, ERR_MOD, ERR_SIGN
      integer ERR_DIM, ERR_MAX, ERR_MIN
      integer ERR_SQRT
      integer ERR_POWER
      integer ERR_POWERBASE, ERR_POWEREXP
      integer ERR_POWERBOTH, ERR_ASIN, ERR_ACOS
      integer ERR_SQRT4CABS

      parameter (ERR_AINT = 1)
      parameter (ERR_ANINT = ERR_AINT + 1)
      parameter (ERR_DNINT = ERR_ANINT)
      parameter (ERR_ABS = ERR_DNINT + 1)
      parameter (ERR_MOD = ERR_ABS + 1)
      parameter (ERR_SIGN = ERR_MOD + 1)
      parameter (ERR_DIM = ERR_SIGN + 1)
      parameter (ERR_MAX = ERR_DIM + 1)
      parameter (ERR_MIN = ERR_MAX + 1)
      parameter (ERR_SQRT = ERR_MIN + 1)

      parameter (ERR_POWER = ERR_SQRT + 1)

      parameter (ERR_POWERBASE = ERR_POWER)
      parameter (ERR_POWEREXP = ERR_POWER)
      parameter (ERR_POWERBOTH = ERR_POWER)

      parameter (ERR_ASIN = ERR_POWER + 1)
      parameter (ERR_ACOS = ERR_ASIN + 1)
      parameter (ERR_SQRT4CABS = ERR_ACOS + 1)

      integer MAX_ERR
      parameter (MAX_ERR = ERR_SQRT4CABS)

      common /ehxcb/ ehxout
      integer ehxout
      common /ehxcbC/ ehCres,
     +        ehCcnt
     
      integer MAX_CONDITIONS
      parameter (MAX_CONDITIONS = 5)

      COMPLEX ehCres(MAX_ERR, MAX_CONDITIONS)
      integer ehCcnt(MAX_ERR, MAX_CONDITIONS)
      if ( type .eq. FUNC_AINT ) then

      else if ( type .eq. FUNC_ANINT ) then

      else if ( type .eq. FUNC_ABS ) then

      else if (type .eq. FUNC_MOD ) then

      fy = ehCres(ERR_MOD,1)

      ehCcnt(ERR_MOD,1) = -29999
      

      else if (type .eq. FUNC_SIGN ) then

      fx = ehCres(ERR_SIGN,1)

      ehCcnt(ERR_SIGN,1) = -29999
      

      else if (type .eq. FUNC_DIM ) then

      fx = ehCres(ERR_DIM,1)

      ehCcnt(ERR_DIM,1) = -29999
      

      else if (type .eq. FUNC_MAX ) then

      fx = ehCres(ERR_MAX,1)

      ehCcnt(ERR_MAX,1) = -29999
      

      else if (type .eq. FUNC_MIN ) then

      fx = ehCres(ERR_MIN,1)

      ehCcnt(ERR_MIN,1) = -29999
      

      else if (type .eq. FUNC_SQRT ) then

      else if (type .eq. FUNC_SQRT4CABS ) then

      else if (type .eq. FUNC_POWERBASE ) then


      


C     Here's the hard coding of precision to get the "real" part of y.
      yreal = DBLE(y)
C             xxxx --- hard coded precision


      if ( x .eq. zero ) then
C        Main case
         if ( yreal .lt. 1.0 ) then
            fx = ehCres(ERR_POWER, 1)
            ehCcnt(ERR_POWER, 1) = -29999
         endif

         if ( yreal .lt. 2.0 ) then
            fxx = ehCres(ERR_POWER, 3)
            ehCcnt(ERR_POWER, 3) = -29999
         endif

      endif


      else if (type .eq. FUNC_POWEREXP ) then

      


C     Here's the hard coding of precision to get the "real" part of y.
      yreal = DBLE(y)
C             xxxx --- hard coded precision


      if ( x .eq. zero ) then
C        Main case
         fy = ehCres(ERR_POWER, 2)
         ehCcnt(ERR_POWER, 2) = -29999

         fyy = ehCres(ERR_POWER, 5)
         ehCcnt(ERR_POWER, 5) = -29999


      else
C          ( x < 0 in real arithmetic; never happens in complex )
         fy = ehCres(ERR_POWER, 2)
         ehCcnt(ERR_POWER, 2) = -29999

         fyy = ehCres(ERR_POWER, 5)
         ehCcnt(ERR_POWER, 5) = -29999

      endif


      else if (type .eq. FUNC_POWERBOTH ) then


      


C     Here's the hard coding of precision to get the "real" part of y.
      yreal = DBLE(y)
C             xxxx --- hard coded precision


      if ( x .eq. zero ) then
C        Main case
         
         if ( yreal .lt. 1.0 ) then
            fx = ehCres(ERR_POWER, 1)
            ehCcnt(ERR_POWER, 1) = -29999
         endif
         fy = ehCres(ERR_POWER, 2)
         ehCcnt(ERR_POWER, 2) = -29999


         if ( yreal .lt. 2.0 ) then
            fxx = ehCres(ERR_POWER, 3)
            ehCcnt(ERR_POWER, 3) = -29999
         endif


         fxy = ehCres(ERR_POWER, 4)
         ehCcnt(ERR_POWER, 4) = -29999


         fyy = ehCres(ERR_POWER, 5)
         ehCcnt(ERR_POWER, 5) = -29999


      else
C          ( x < 0 in real arithmetic; never happens in complex )
         fy = ehCres(ERR_POWER, 2)
         ehCcnt(ERR_POWER, 2) = -29999

         fxy = ehCres(ERR_POWER, 4)
         ehCcnt(ERR_POWER, 4) = -29999


         fyy = ehCres(ERR_POWER, 5)
         ehCcnt(ERR_POWER, 5) = -29999

      endif

      else if (type .eq. FUNC_ASIN ) then

      else if (type .eq. FUNC_ACOS ) then

      else
         stop 'Received unknown function in exception handler.'
      endif






      return
      end
