C  --------------------------------------------------------------
C (C) COPYRIGHT 1994, 1996 University of Chicago
C   
C   THIS PROGRAM DISCLOSES MATERIAL PROTECTABLE UNDER COPYRIGHT
C   LAWS OF THE UNITED STATES. USE IS PERMITTED WITHOUT FEE FOR
C   EDUCATION AND NON-PROFIT RESEARCH PURPOSES SUBJECT TO THE
C   TERMS OF A LICENSE DISTRIBUTED WITH THE ADIFOR 2.0 SOFTWARE
C   AND AVAILABLE AT:
C   http://www.mcs.anl.gov/autodiff/adifor_license.html, or
C   http://www.cs.rice.edu/~adifor/AdiforPublicLicense.html.
C   ANY ENTITY DESIRING PERMISSION TO INCORPORATE THIS SOFTWARE
C   OR A WORK BASED ON THE SOFTWARE INTO COMMERCIAL PRODUCTS OR
C   OTHERWISE USE IT FOR COMMERCIAL PURPOSES SHOULD CONTACT:
C   
C   Paul Hovland, Mathematics and Computer Science Division,
C   Argonne National Laboratory, 9700 S. Cass Avenue, Argonne IL
C   60439, hovland@mcs.anl.gov.
C   
C   Alan Carle, Center for Research on Parallel Computation, Rice
C   University MS 41, 6100 Main Street, Houston, TX 77005,
C   carle@cs.rice.edu.
C  --------------------------------------------------------------
C
      subroutine ehsevC (symbolic, value)
      integer FUNC_AINT, FUNC_ANINT, FUNC_DNINT, FUNC_ABS, FUNC_MOD
      integer FUNC_SIGN, FUNC_DIM, FUNC_MAX, FUNC_MIN
      integer FUNC_SQRT, FUNC_SQRT4CABS
      integer FUNC_POWERBASE, FUNC_POWEREXP, FUNC_POWERBOTH
      integer FUNC_ASIN, FUNC_ACOS

      parameter (FUNC_AINT = 1)
      parameter (FUNC_ANINT = 2)
      parameter (FUNC_DNINT = 2)
      parameter (FUNC_ABS = 3)
      parameter (FUNC_MOD = 4)      
      parameter (FUNC_SIGN = 5)
      parameter (FUNC_DIM = 6)
      parameter (FUNC_MAX = 7)
      parameter (FUNC_MIN = 8)
      parameter (FUNC_SQRT = 9)
      parameter (FUNC_POWERBASE = 10)      
      parameter (FUNC_POWEREXP = 11)      
      parameter (FUNC_POWERBOTH = 12)      
      parameter (FUNC_ASIN = 13)
      parameter (FUNC_ACOS = 14)
      parameter (FUNC_SQRT4CABS = 15)

      integer MAX_FN
      parameter (MAX_FN = FUNC_SQRT4CABS)

      integer ERR_AINT, ERR_ANINT, ERR_DNINT
      integer ERR_ABS, ERR_MOD, ERR_SIGN
      integer ERR_DIM, ERR_MAX, ERR_MIN
      integer ERR_SQRT
      integer ERR_POWER
      integer ERR_POWERBASE, ERR_POWEREXP
      integer ERR_POWERBOTH, ERR_ASIN, ERR_ACOS
      integer ERR_SQRT4CABS

      parameter (ERR_AINT = 1)
      parameter (ERR_ANINT = ERR_AINT + 1)
      parameter (ERR_DNINT = ERR_ANINT)
      parameter (ERR_ABS = ERR_DNINT + 1)
      parameter (ERR_MOD = ERR_ABS + 1)
      parameter (ERR_SIGN = ERR_MOD + 1)
      parameter (ERR_DIM = ERR_SIGN + 1)
      parameter (ERR_MAX = ERR_DIM + 1)
      parameter (ERR_MIN = ERR_MAX + 1)
      parameter (ERR_SQRT = ERR_MIN + 1)

      parameter (ERR_POWER = ERR_SQRT + 1)

      parameter (ERR_POWERBASE = ERR_POWER)
      parameter (ERR_POWEREXP = ERR_POWER)
      parameter (ERR_POWERBOTH = ERR_POWER)

      parameter (ERR_ASIN = ERR_POWER + 1)
      parameter (ERR_ACOS = ERR_ASIN + 1)
      parameter (ERR_SQRT4CABS = ERR_ACOS + 1)

      integer MAX_ERR
      parameter (MAX_ERR = ERR_SQRT4CABS)

      common /ehxcb/ ehxout
      integer ehxout
      common /ehxcbC/ ehCres,
     +        ehCcnt
     
      integer MAX_CONDITIONS
      parameter (MAX_CONDITIONS = 5)

      COMPLEX ehCres(MAX_ERR, MAX_CONDITIONS)
      integer ehCcnt(MAX_ERR, MAX_CONDITIONS)

      integer symbolic
      COMPLEX value

      integer i
      integer place, offset

      integer eINFs(2, 12)
      integer eNANs(2, 6)
      integer eNoLimits(2, 6)
      integer eTies(2, 3)
      integer eJumps(2, 5)


      data eINFs /
     +     ERR_POWER, 2, ERR_POWER, 5,
     +     ERR_ASIN, 1, ERR_ASIN, 2, 
     +     ERR_ACOS, 1, ERR_ACOS, 2, 
     +     ERR_POWER, 5,
     +     -1, -1,
     +     -1, -1,
     +     -1, -1,
     +     -1, -1,
     +     -1, -1/ 



      data eNANs /
     +     ERR_SQRT, 1, ERR_SQRT, 2,
     +     ERR_POWER, 1,
     +     ERR_POWER, 3,
     +     ERR_POWER, 4,
     +     -1, -1/



      data eNoLimits /
     +     ERR_ABS, 1,
     +     ERR_SIGN, 1,
     +     ERR_DIM, 1,
     +     -1, -1,
     +     -1, -1,
     +     -1, -1/


      data eTies /
     +     ERR_MAX, 1,
     +     ERR_MIN, 1,
     +     -1, -1/

      data eJumps /
     +     ERR_AINT, 1,
     +     ERR_ANINT, 1,
     +     ERR_DNINT, 1,
     +     ERR_MOD, 1,
     +     -1, -1/


      i = 0
 911  i = i+1

      if ( symbolic .eq. 1 ) then
         place = eINFs(1,i)
         offset = eINFs(2,i)
      else if (symbolic .eq. 2 ) then
         place = eNANs(1,i)
         offset = eNANs(2,i)
      else if (symbolic .eq. 3 ) then
         place = eNoLimits(1,i)
         offset = eNoLimits(2,i)
      else if (symbolic .eq. 4 ) then
         place = eTies(1,i)
         offset = eTies(2,i)
      else if (symbolic .eq. 5 ) then
         place = eJumps(1,i)
         offset = eJumps(2,i)
      endif
      
      if ( place .eq. -1 ) goto 912

      ehCres(place, offset) = value
      goto 911
         
 912  continue

      return
      end
