
#include <stdio.h>

#define MAX_NAMELEN 2

static char name[MAX_NAMELEN];
static char *program_name; 

int main(argc, argv)
int argc;
char *argv[];
{

 FILE *fp9;
 int minarity, MAXARITY, ARITY;
 int i, j;
 
 program_name = argv[0];
 if(argc != 3) {
   fprintf (stderr, "Usage: %s <min-arity> <max-arity>\n", program_name);
   exit(1); }
 else {
   minarity = atoi(argv[1]);
   MAXARITY = atoi(argv[2]);
 }

 fp9 = fopen("advis_pd_int.c", "w");

 fprintf(fp9, "#include \"PREC_advis_pd_int_custom.c\" \n");

 for(j=minarity; j<=MAXARITY; j++) {

    ARITY = MAXARITY - (MAXARITY - j);

    fprintf(fp9, "\n \nvoid spg%d_ca(destptrptr,", ARITY);

    /* Parameter list */

    for(i=0; i<=ARITY-2; i++) {
       getname(i, name);
       fprintf(fp9, "%sptr,%sptrptr,", name, name);
    }
    getname(ARITY - 1, name);
    fprintf(fp9, "%sptr,%sptrptr,lineno,filename) \n", name, name);

    /* Declaration */

    fprintf(fp9, "\n  int *lineno;\n");
    fprintf(fp9, "  char *filename;\n");

    fprintf(fp9, "  PREC_vectorstruct **destptrptr, ");
    for(i=0; i<=ARITY-2; i++) {
       getname(i, name);
       fprintf(fp9, "**%sptrptr,", name);
    }
    getname(ARITY - 1, name);
    fprintf(fp9, "**%sptrptr;", name);

    fprintf(fp9, "\n  FLOATING_DECLARE ");
    for(i=0; i<=ARITY-2; i++) { 
       getname(i, name);
       fprintf(fp9, "*%sptr,", name);
    }
    getname(ARITY - 1, name);
    fprintf(fp9, "*%sptr;\n", name);

    fprintf(fp9, "\n{\n");

    /* Body */

    fprintf(fp9, "\n#ifdef _VTRACE");
    fprintf(fp9, "\n   int effect_arity = 0;");
    fprintf(fp9, "\n   int no_of_zero_vecs = 0;");
    fprintf(fp9, "\n   int no_of_zero_mult = 0;");
    fprintf(fp9, "\n   int no_of_zero_both = 0;");
    fprintf(fp9, "\n   int old_dstype = 0;");
    fprintf(fp9, "\n   int new_dstype = 0;");
    fprintf(fp9, "\n   int old_nz = 0;");
    fprintf(fp9, "\n   int new_nz = 0;");
    fprintf(fp9, "\n   int real_time = 0;");
    fprintf(fp9, "\n   struct tms tmrec;");
    fprintf(fp9, "\n   short lhs_is_in_rhs = FALSE;");
    fprintf(fp9, "\n   int rhs_nz_sum = 0;");

    for(i=0; i<ARITY; i++) {
       getname(i, name);
       fprintf(fp9, "\n   if ((*%sptrptr) != NULL) {", name);
       fprintf(fp9, "\n      if(!((*%sptrptr)->nonzeroes)) no_of_zero_vecs++;", name);
       fprintf(fp9, "\n      if(X_IS_ZERO(*%sptr)) no_of_zero_mult++;", name);
       fprintf(fp9, "\n      if((*%sptrptr)->nonzeroes && !X_IS_ZERO(*%sptr)) effect_arity++;", name, name);
      fprintf(fp9, "\n      if(!((*%sptrptr)->nonzeroes || !X_IS_ZERO(*%sptr))) no_of_zero_both++;", name, name);
      fprintf(fp9, "\n      if ((*%sptrptr) == (*destptrptr)) lhs_is_in_rhs = TRUE;", name);
      fprintf(fp9, "\n      MULT_COUNT += (*%sptrptr)->nonzeroes;", name);
      fprintf(fp9, "\n      rhs_nz_sum += (*%sptrptr)->nonzeroes;", name);
      fprintf(fp9, "\n   }");
    }

    fprintf(fp9, "\n   if ((*destptrptr) != NULL) {");
    fprintf(fp9, "\n      old_dstype = (*destptrptr)->dstype;");
    fprintf(fp9, "\n      old_nz = (*destptrptr)->nonzeroes;");
    fprintf(fp9, "\n   }");
    fprintf(fp9, "\n#endif\n");
    fprintf(fp9, "\nadxpy%d(destptrptr,", ARITY);

    for(i=0; i<=ARITY-2; i++) {
       getname(i, name);
       fprintf(fp9, "%sptr,%sptrptr,", name, name);
    }
    getname(ARITY - 1, name);
    fprintf(fp9, "%sptr,%sptrptr,lineno,filename); \n", name, name);

    fprintf(fp9, "\n#ifdef _VTRACE");
    fprintf(fp9, "\n   new_dstype = (*destptrptr)->dstype;");
    fprintf(fp9, "\n   new_nz = (*destptrptr)->nonzeroes;");
    fprintf(fp9, "\n   times(&tmrec); real_time = (long)tmrec.tms_utime;\n");
    fprintf(fp9, "\n   ADXPY_CALLS++;");
    fprintf(fp9, "\n   if(effect_arity)");
    fprintf(fp9, "\n     ADD_COUNT += ((rhs_nz_sum - new_nz) / effect_arity);");
    fprintf(fp9, "\n   collect_visual(%d, effect_arity, no_of_zero_vecs, no_of_zero_mult, no_of_zero_both, lhs_is_in_rhs, old_dstype, new_dstype, FALSE);", ARITY);
    fprintf(fp9, "\n   update_vector((*destptrptr), real_time, %d, effect_arity, new_dstype);", ARITY);
    fprintf(fp9, "\n#endif\n");

    fprintf(fp9, "\n} \n");

 }

 return 0;
}

/*************************************************
*    Getname is called with i = 0 ... ARITY-1    *
*************************************************/

getname(i, name)
int i;
char name[];
{
     int index =0;
     int loop;

     while ( i != 0 )
     {
	  name[index] = 'a' + ( i % 26 ) ;

	  /* Start at next position */
	  index++;

	  /* Find how much of `i' is left */
	  i = i / 26 ;
     }
	  
     if ( index > MAX_NAMELEN )
     {
	  fprintf (stderr,"%s: string length not long enough for ARITY\n",program_name);
	  exit(1);
     }

     for ( loop = index; loop < MAX_NAMELEN; loop++ )
     {
	  name[loop]='a';
     }

}

