/*------------------------------------------------------------------*/
/* (C) COPYRIGHT 1996 Rice University                               */
/*------------------------------------------------------------------*/
/*                                                                  */
/* This file uses cfortran.h to generate the appropriate code to    */
/* interface correctly between C and Fortran compilers on various   */
/* machines.                                                        */
/*                                                                  */
/*------------------------------------------------------------------*/

#include "cfortran.h"

#define FC0(i,un,ln) FCALLSCSUB0(i,un,ln)
#define FC1(i,un,ln) FCALLSCSUB1(i,un,ln,PINT)
#define FC2(i,un,ln) FCALLSCSUB2(i,un,ln,PINT,PINT)
#define FC3(i,un,ln) FCALLSCSUB3(i,un,ln,PINT,PINT,PINT)
#define FC4(i,un,ln) FCALLSCSUB4(i,un,ln,PINT,PINT,PINT,PINT)
#define FC5(i,un,ln) FCALLSCSUB5(i,un,ln,PINT,PINT,PINT,PINT,PINT)
#define FC6(i,un,ln) FCALLSCSUB6(i,un,ln,PINT,PINT,PINT,PINT,PINT,\
				 PINT)
#define FC7(i,un,ln) FCALLSCSUB7(i,un,ln,PINT,PINT,PINT,PINT,PINT,\
				 PINT,PINT)
#define FC9(i,un,ln) FCALLSCSUB9(i,un,ln,PINT,PINT,PINT,PINT,PINT,\
				 PINT,PINT,PINT,PINT)
#define FC11(i,un,ln) FCALLSCSUB11(i,un,ln,PINT,PINT,PINT,PINT,PINT,\
				 PINT,PINT,PINT,PINT,PINT,PINT)

FC3(dsp2c_internal,DSP2C,dsp2c)
FC3(ssp2c_internal,SSP2C,ssp2c)

FC2(csp2d_internal,CSP2D,csp2d)
FC2(dsp2d_internal,DSP2D,dsp2d)
FC2(ssp2d_internal,SSP2D,ssp2d)
FC2(zsp2d_internal,ZSP2D,zsp2d)

FC2(csp2s_internal,CSP2S,csp2s)
FC2(dsp2s_internal,DSP2S,dsp2s)
FC2(ssp2s_internal,SSP2S,ssp2s)
FC2(zsp2s_internal,ZSP2S,zsp2s)

FC3(dsp2z_internal,DSP2Z,dsp2z)
FC3(ssp2z_internal,SSP2Z,ssp2z)

FC2(cspcj_internal,CSPCJ,cspcj)
FC2(zspcj_internal,ZSPCJ,zspcj)

FC2(cspcp_internal,CSPCP,cspcp)
FC2(dspcp_internal,DSPCP,dspcp)
FC2(sspcp_internal,SSPCP,sspcp)
FC2(zspcp_internal,ZSPCP,zspcp)

FC3(cspg1_internal,CSPG1,cspg1)
FC3(dspg1_internal,DSPG1,dspg1)
FC3(sspg1_internal,SSPG1,sspg1)
FC3(zspg1_internal,ZSPG1,zspg1)

FC5(cspg2_internal,CSPG2,cspg2)
FC5(dspg2_internal,DSPG2,dspg2)
FC5(sspg2_internal,SSPG2,sspg2)
FC5(zspg2_internal,ZSPG2,zspg2)

FC7(cspg3_internal,CSPG3,cspg3)
FC7(dspg3_internal,DSPG3,dspg3)
FC7(sspg3_internal,SSPG3,sspg3)
FC7(zspg3_internal,ZSPG3,zspg3)

FC9(cspg4_internal,CSPG4,cspg4)
FC9(dspg4_internal,DSPG4,dspg4)
FC9(sspg4_internal,SSPG4,sspg4)
FC9(zspg4_internal,ZSPG4,zspg4)

FC11(cspg5_internal,CSPG5,cspg5)
FC11(dspg5_internal,DSPG5,dspg5)
FC11(sspg5_internal,SSPG5,sspg5)
FC11(zspg5_internal,ZSPG5,zspg5)

FC4(cspgx_internal,CSPGX,cspgx)
FC4(dspgx_internal,DSPGX,dspgx)
FC4(sspgx_internal,SSPGX,sspgx)
FC4(zspgx_internal,ZSPGX,zspgx)

FC2(cspim_internal,CSPIM,cspim)
FC2(zspim_internal,ZSPIM,zspim)

FC2(csppr_internal,CSPPR,csppr)
FC2(dsppr_internal,DSPPR,dsppr)
FC2(ssppr_internal,SSPPR,ssppr)
FC2(zsppr_internal,ZSPPR,zsppr)

FC4(cspsd_internal,CSPSD,cspsd)
FC4(dspsd_internal,DSPSD,dspsd)
FC4(sspsd_internal,SSPSD,sspsd)
FC4(zspsd_internal,ZSPSD,zspsd)

FC5(cspxa_internal,CSPXA,cspxa)
FC5(dspxa_internal,DSPXA,dspxa)
FC5(sspxa_internal,SSPXA,sspxa)
FC5(zspxa_internal,ZSPXA,zspxa)

FC5(cspxd_internal,CSPXD,cspxd)
FC5(dspxd_internal,DSPXD,dspxd)
FC5(sspxd_internal,SSPXD,sspxd)
FC5(zspxd_internal,ZSPXD,zspxd)

FC6(cspxm_internal,CSPXM,cspxm)
FC6(dspxm_internal,DSPXM,dspxm)
FC6(sspxm_internal,SSPXM,sspxm)
FC6(zspxm_internal,ZSPXM,zspxm)

FC6(cspxs_internal,CSPXS,cspxs)
FC6(dspxs_internal,DSPXS,dspxs)
FC6(sspxs_internal,SSPXS,sspxs)
FC6(zspxs_internal,ZSPXS,zspxs)

FC1(cspzronotca_internal, CSPZRONOTCA, cspzronotca)
FC1(dspzronotca_internal, DSPZRONOTCA, dspzronotca)
FC1(sspzronotca_internal, SSPZRONOTCA, sspzronotca)
FC1(zspzronotca_internal, ZSPZRONOTCA, zspzronotca)

FC0(xspfra_internal, XSPFRA, xspfra)
FC0(xspini_internal, XSPINI, xspini)
FC2(xspcnx_internal, XSPCNX, xspcnx)
FC2(xspcnf_internal, XSPCNF, xspcnf)
FC2(xspmex_internal, XSPMEX, xspmex)
FC1(xspmem_internal, XSPMEM, xspmem)

#ifdef _VTRACE

FC2(cspcp_ca_internal,CSPCP_CA,cspcp_ca)
FC2(dspcp_ca_internal,DSPCP_CA,dspcp_ca)
FC2(sspcp_ca_internal,SSPCP_CA,sspcp_ca)
FC2(zspcp_ca_internal,ZSPCP_CA,zspcp_ca)

FC3(cspg1_ca_internal,CSPG1_CA,cspg1_ca)
FC3(dspg1_ca_internal,DSPG1_CA,dspg1_ca)
FC3(sspg1_ca_internal,SSPG1_CA,sspg1_ca)
FC3(zspg1_ca_internal,ZSPG1_CA,zspg1_ca)

FC5(cspg2_ca_internal,CSPG2_CA,cspg2_ca)
FC5(dspg2_ca_internal,DSPG2_CA,dspg2_ca)
FC5(sspg2_ca_internal,SSPG2_CA,sspg2_ca)
FC5(zspg2_ca_internal,ZSPG2_CA,zspg2_ca)

FC7(cspg3_ca_internal,CSPG3_CA,cspg3_ca)
FC7(dspg3_ca_internal,DSPG3_CA,dspg3_ca)
FC7(sspg3_ca_internal,SSPG3_CA,sspg3_ca)
FC7(zspg3_ca_internal,ZSPG3_CA,zspg3_ca)

FC9(cspg4_ca_internal,CSPG4_CA,cspg4_ca)
FC9(dspg4_ca_internal,DSPG4_CA,dspg4_ca)
FC9(sspg4_ca_internal,SSPG4_CA,sspg4_ca)
FC9(zspg4_ca_internal,ZSPG4_CA,zspg4_ca)

FC11(cspg5_ca_internal,CSPG5_CA,cspg5_ca)
FC11(dspg5_ca_internal,DSPG5_CA,dspg5_ca)
FC11(sspg5_ca_internal,SSPG5_CA,sspg5_ca)
FC11(zspg5_ca_internal,ZSPG5_CA,zspg5_ca)

FC4(cspgx_ca_internal,CSPGX_CA,cspgx_ca)
FC4(dspgx_ca_internal,DSPGX_CA,dspgx_ca)
FC4(sspgx_ca_internal,SSPGX_CA,sspgx_ca)
FC4(zspgx_ca_internal,ZSPGX_CA,zspgx_ca)

FC1(cspzro_ca_internal, CSPZRO_CA, cspzro_ca)
FC1(dspzro_ca_internal, DSPZRO_CA, dspzro_ca)
FC1(sspzro_ca_internal, SSPZRO_CA, sspzro_ca)
FC1(zspzro_ca_internal, ZSPZRO_CA, zspzro_ca)

FC0(xvscls_internal, XVSCLS, xvscls)
FC0(xvsini_internal, XVSINI, xvsini)
FC2(xvscnf_internal, XVSCNF, xvscnf)
FC0(xvsdef_internal, XVSDEF, xvsdef)

#endif /* _VTRACE */
