#define COMPLEX
/*------------------------------------------------------------------*/
/* (C) COPYRIGHT 1994 University of Chicago                         */
/*                                                                  */
/* THIS PROGRAM DISCLOSES MATERIAL PROTECTABLE UNDER COPYRIGHT      */
/* LAWS OF THE UNITED STATES. USE IS PERMITTED WITHOUT FEE FOR      */
/* EDUCATION AND NON-PROFIT RESEARCH PURPOSES SUBJECT TO THE        */
/* TERMS OF A LICENSE DISTRIBUTED WITH THE ADIFOR 2.0 SOFTWARE      */
/* AND AVAILABLE AT:                                                */
/* http://www.mcs.anl.gov/autodiff/adifor_license.html, or          */
/* http://www.cs.rice.edu/fortran-tools/ADIFOR/adifor_license.html. */
/* ANY ENTITY DESIRING PERMISSION TO INCORPORATE THIS SOFTWARE      */
/* OR A WORK BASED ON THE SOFTWARE INTO COMMERCIAL PRODUCTS OR      */
/* OTHERWISE USE IT FOR COMMERCIAL PURPOSES SHOULD CONTACT:         */
/*                                                                  */
/* Paul Hovland, Mathematics and Computer Science Division,    */
/* Argonne National Laboratory, 9700 S. Cass Avenue, Argonne IL     */
/* 60439, hovland@mcs.anl.gov.                                      */
/*                                                                  */
/* Alan Carle, Center for Research on Parallel Computation, Rice    */
/* University MS 41, 6100 S. Main Street, Houston, TX 77251-1892,   */
/* carle@cs.rice.edu.                                               */
/*------------------------------------------------------------------*/


#include  <stdlib.h>
#include "cgaxpy_pd_macros_and_data_structures.h"
#include "cgaxpy_pd_global_variables.h"

/****************************************************************************
 *                                                                          *
 *    plusequalcspg1 performs the arity 1 gaxpy when the lhsvector is the  *
 *    same as the rhsvector.                                                *
 *                                                                          *
 ****************************************************************************/

void plusequalcspg1(rhsanddestptrptr,alphaptr)
cvectorstruct **rhsanddestptrptr;
complex *alphaptr;
{

  cbucketstruct *bucketptr;
  cvbucketstruct *vbucketptr;
  int i,bucketindex,vbucketindex;

  if ((*rhsanddestptrptr)->dstype == S1) {
    GAXPY_EQUALS((*rhsanddestptrptr)->cds.s1.value,*alphaptr,
		 (*rhsanddestptrptr)->cds.s1.value);
  }
  else if ((*rhsanddestptrptr)->dstype == SS) {   
    bucketptr = (*rhsanddestptrptr)->cds.ss.bucketptr;
    for(i=0;i<(*rhsanddestptrptr)->nonzeroes;i++) {
      if(((bucketindex=MY_MOD(i,cBUCKET_DIM_minus1)) == 0) && i!=0)
	bucketptr = bucketptr->nextbucket;
      GAXPY_EQUALS(bucketptr->value[bucketindex],*alphaptr,
		   bucketptr->value[bucketindex]);
    }
  }
  else /* if ((*rhsanddestptrptr)->dstype == CS) */ {
    vbucketptr = (*rhsanddestptrptr)->cds.cs.vbucketptr;
    for(i=0;i<(*rhsanddestptrptr)->nonzeroes;i++) {
      if(((vbucketindex=MY_MOD(i,cVBUCKET_DIM_minus1)) == 0) && i!=0)
	vbucketptr = vbucketptr->nextvbucket;
      GAXPY_EQUALS(vbucketptr->value[vbucketindex], *alphaptr,
		   vbucketptr->value[vbucketindex]);
    }
  }
}

