/*------------------------------------------------------------------*/
/* (C) COPYRIGHT 1994 University of Chicago                         */
/*                                                                  */
/* THIS PROGRAM DISCLOSES MATERIAL PROTECTABLE UNDER COPYRIGHT      */
/* LAWS OF THE UNITED STATES. USE IS PERMITTED WITHOUT FEE FOR      */
/* EDUCATION AND NON-PROFIT RESEARCH PURPOSES SUBJECT TO THE        */
/* TERMS OF A LICENSE DISTRIBUTED WITH THE ADIFOR 2.0 SOFTWARE      */
/* AND AVAILABLE AT:                                                */
/* http://www.mcs.anl.gov/autodiff/adifor_license.html, or          */
/* http://www.cs.rice.edu/fortran-tools/ADIFOR/adifor_license.html. */
/* ANY ENTITY DESIRING PERMISSION TO INCORPORATE THIS SOFTWARE      */
/* OR A WORK BASED ON THE SOFTWARE INTO COMMERCIAL PRODUCTS OR      */
/* OTHERWISE USE IT FOR COMMERCIAL PURPOSES SHOULD CONTACT:         */
/*                                                                  */
/* Paul Hovland, Mathematics and Computer Science Division,    */
/* Argonne National Laboratory, 9700 S. Cass Avenue, Argonne IL     */
/* 60439, hovland@mcs.anl.gov.                                      */
/*                                                                  */
/* Alan Carle, Center for Research on Parallel Computation, Rice    */
/* University MS 41, 6100 S. Main Street, Houston, TX 77251-1892,   */
/* carle@cs.rice.edu.                                               */
/*------------------------------------------------------------------*/


#ifndef GAXPY_PI_GLOBAL_VARIABLES

#define GAXPY_PI_GLOBAL_VARIABLES

#ifdef DEFINE_GLOBALS
#define GLOBAL
#else
#define GLOBAL extern
#endif


 /***************************************************************************
 *                                                                          *
 *  Global Variables                                                        *
 *                                                                          *
 ****************************************************************************/

/******************
 *  HEAP STUFF    *
 ******************/

GLOBAL heapstruct *heaproot;                 /* Pointer to root of heap.    */

GLOBAL int heapstoreptr;                     /* Array index of next avail-  *
					      * able heapstore location.    */


/******************
 *  OTHER STUFF   *
 ******************/

GLOBAL int INITIALIZED_MAXINDEX;             /* Flag to indicate that       *
					      * g$p$ has been initialized   *
					      * == 0 : not initialized yet. *
					      * == 1 : already initialized. */

GLOBAL int GLOBAL_MAXINDEX;              /* Global value of maxindex (g$p$) */


GLOBAL int SWITCH_NZ_VALUE;        /* Number of nonzero values at which a   *
				    * vector switches from SS to CS.        */

GLOBAL float SWITCH_NZ_RATIO;      /* Ratio of (nonzero values/g$p$) at     *
				    * which a vector switches from SS to CS.*/


GLOBAL float MEM_ALLOCATED[5][5];  /* count of memory allocated.            */

GLOBAL int toggle_adxpy_1_peep;

#ifdef _PEEP

GLOBAL FILE *fp;
GLOBAL int fileopenflag;

#endif


#ifdef _MEMORY_CHECK

GLOBAL FILE *fp2;
GLOBAL int fileopenflag2;
GLOBAL int total_mallocs_size;

#endif



#endif   /*  #ifndef GAXPY_PI_GLOBAL_VARIABLES  */
