#define COMPLEX
/*------------------------------------------------------------------*/
/* (C) COPYRIGHT 1994 University of Chicago                         */
/*                                                                  */
/* THIS PROGRAM DISCLOSES MATERIAL PROTECTABLE UNDER COPYRIGHT      */
/* LAWS OF THE UNITED STATES. USE IS PERMITTED WITHOUT FEE FOR      */
/* EDUCATION AND NON-PROFIT RESEARCH PURPOSES SUBJECT TO THE        */
/* TERMS OF A LICENSE DISTRIBUTED WITH THE ADIFOR 2.0 SOFTWARE      */
/* AND AVAILABLE AT:                                                */
/* http://www.mcs.anl.gov/autodiff/adifor_license.html, or          */
/* http://www.cs.rice.edu/fortran-tools/ADIFOR/adifor_license.html. */
/* ANY ENTITY DESIRING PERMISSION TO INCORPORATE THIS SOFTWARE      */
/* OR A WORK BASED ON THE SOFTWARE INTO COMMERCIAL PRODUCTS OR      */
/* OTHERWISE USE IT FOR COMMERCIAL PURPOSES SHOULD CONTACT:         */
/*                                                                  */
/* Paul Hovland, Mathematics and Computer Science Division,    */
/* Argonne National Laboratory, 9700 S. Cass Avenue, Argonne IL     */
/* 60439, hovland@mcs.anl.gov.                                      */
/*                                                                  */
/* Alan Carle, Center for Research on Parallel Computation, Rice    */
/* University MS 41, 6100 S. Main Street, Houston, TX 77251-1892,   */
/* carle@cs.rice.edu.                                               */
/*------------------------------------------------------------------*/


#include  <stdlib.h>
#include "sgaxpy_pd_macros_and_data_structures.h"
#include "cgaxpy_pd_macros_and_data_structures.h"
#include "sgaxpy_pd_global_variables.h"
#include "cgaxpy_pd_global_variables.h"


/*
 *  Function Prototyping done locally to grab "TO_pREc_" correctly.
 */

#define _P(x) ()

void snon_over_lapping_cs_range_convert_to_c _P((
				  int rangedestination,
				  int lhscibucketindex,
				  int *addressoflastlhscibucketindex,
				  int *addressoflhscvbucketindex,
				  int k,
				  int *addressofrhsvbucketindex_k,
				  int totalcurrentnonzerorange
#ifdef _DEBUG
				  ,int *addressofunconsumedcurrentnonzerorange
				  ,int rhsvectorconsumednonzeroranges_k
				  ,int rhsvectornonzeroranges_k
				  ,int lhscvectornonzeroranges
#endif
				  ));

void soverlapping_cs_range_convert_to_c _P((
			     int *addressoflhscvbucketindex,
			     int k,
			     int *addressofrhsvbucketindex_k,
			     int totalcurrentnonzerorange
#ifdef _DEBUG
			     ,int *addressofunconsumedcurrentnonzerorange
			     ,int rhsvectorconsumednonzeroranges_k
			     ,int rhsvectornonzeroranges_k
			     ,int lhscvectornonzeroranges
#endif
			     ));


void sdense_convert_to_c_loop _P((int range,
					int *lhscvbucketindex,
					int *rhssvbucketindex,
					int k,
					int loopsize
#ifdef _DEBUG
					,int *unconsumedcurrentnonzerorange
#endif
					));

void sget_and_hop_to_next_to_c_vbucket _P((int* lhscvbucketindex));

/*
 * Unnecessary code prototype
 *
void axpy_0_1_to_c_post_processing _P((
		    cvectorstruct **destptrptr));
 *
 * End of Unnecessary code prototype
 */

void saxpy_2_heap_to_c_post_processing _P((
		    cvectorstruct **destptrptr,
		    svectorstruct **rhssvectorptrptrs[],
		    svectorstruct *restorerhssvectorptr[MAXARITY+1],
		    int arity,
		    int lhssvectornonzeroes,
		    int lhssvectornonzeroranges,
		    int governingdstype));

/****************************************************************************
 *                                                                          *
 *      All rhs objects are s objects, whereas all lhs objects are      *
 *      c objects.  We omit the prefix s for the rhs objects     *
 *      everywhere except in the "dense-convert" routine, since every       *
 *      other rhs object passed is int except rhssvbucketptrptr, which  *
 *      is a global and which is only used in the "dense-convert" routine.  *
 *                                                                          *
 ****************************************************************************/

void snon_over_lapping_cs_range_convert_to_c(
				  rangedestination,
				  lhscibucketindex,
				  addressoflastlhscibucketindex,
				  addressoflhscvbucketindex,
				  k,
				  addressofrhsvbucketindex_k,
				  totalcurrentnonzerorange
#ifdef _DEBUG
				  ,addressofunconsumedcurrentnonzerorange
				  ,rhsvectorconsumednonzeroranges_k
				  ,rhsvectornonzeroranges_k
				  ,lhscvectornonzeroranges
#endif
				  )
int rangedestination;
int lhscibucketindex;
int *addressoflastlhscibucketindex;
int *addressoflhscvbucketindex;
int k;
int *addressofrhsvbucketindex_k;
int totalcurrentnonzerorange;
#ifdef _DEBUG
int *addressofunconsumedcurrentnonzerorange;
int rhsvectorconsumednonzeroranges_k;
int rhsvectornonzeroranges_k;
int lhscvectornonzeroranges;
#endif
{
  int firstloopsize;
  int numberofdoubleforloopiterations;
  int firstiterationloopsize;
  int seconditerationloopsize;
  int remainder1loopsize;
  int remainder2loopsize;

  int i;


  sDETERMINE_LOOP_BOUNDS(totalcurrentnonzerorange,
			*addressoflhscvbucketindex,
			*addressofrhsvbucketindex_k,
			&firstloopsize,
			&numberofdoubleforloopiterations,
			&firstiterationloopsize,
			&seconditerationloopsize,
			&remainder1loopsize,
			&remainder2loopsize,
			addressofunconsumedcurrentnonzerorange);
  sDENSE_CONVERT_TO_c_LOOP(NEW_RANGE,
				 addressoflhscvbucketindex,
				 addressofrhsvbucketindex_k,
				 k,
				 firstloopsize,
				 addressofunconsumedcurrentnonzerorange);
  
  
  /************************************************
   * Case 1: rhssvbucket has more spaces      *
   *         remaining than lhscvbucket.   *
   ************************************************/
  
  if (*addressofrhsvbucketindex_k <
      *addressoflhscvbucketindex) {
    
    for(i=0;i<numberofdoubleforloopiterations;i++) {
      sDEBUGGING_CODE_1(LEFT,
		       *addressoflhscvbucketindex,
		       *addressofunconsumedcurrentnonzerorange);
      sget_and_hop_to_next_vbucket(addressoflhscvbucketindex);
      sDENSE_CONVERT_TO_c_LOOP(NEW_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     firstiterationloopsize,
				     addressofunconsumedcurrentnonzerorange);
      sDEBUGGING_CODE_1(RIGHT,
		       *addressofrhsvbucketindex_k,
		       *addressofunconsumedcurrentnonzerorange);
      sHOP_TO_NEXT_RHSVBUCKET(k,
			     addressofrhsvbucketindex_k,
			     rhsvectorconsumednonzeroranges_k,
			     rhsvectornonzeroranges_k);
      sDENSE_CONVERT_TO_c_LOOP(NEW_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     seconditerationloopsize,
				     addressofunconsumedcurrentnonzerorange);
    }
    
    if (remainder1loopsize > 0) {
      sDEBUGGING_CODE_1(LEFT,
		       *addressoflhscvbucketindex,
		       *addressofunconsumedcurrentnonzerorange);
      sget_and_hop_to_next_vbucket(addressoflhscvbucketindex);
      sDENSE_CONVERT_TO_c_LOOP(NEW_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     remainder1loopsize,
				     addressofunconsumedcurrentnonzerorange);
    }
    if (remainder2loopsize > 0) {
      sDEBUGGING_CODE_1(RIGHT,
		       *addressofrhsvbucketindex_k,
		       *addressofunconsumedcurrentnonzerorange);
      sHOP_TO_NEXT_RHSVBUCKET(k,
			     addressofrhsvbucketindex_k,
			     rhsvectorconsumednonzeroranges_k,
			     rhsvectornonzeroranges_k);
      sDENSE_CONVERT_TO_c_LOOP(NEW_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     remainder2loopsize,
				     addressofunconsumedcurrentnonzerorange);
    }
    DEBUGGING_CODE_2(*addressofunconsumedcurrentnonzerorange);
    if (rangedestination == COMPLETELY_NEW_RANGE) {
      *addressoflastlhscibucketindex = lhscibucketindex;
    }
  }
  
  /*********************************************
   * Case 2: rhssvbucket has less spaces   *
   * remaining than lhscvbucket.        *
   *********************************************/	  
  else if (*addressofrhsvbucketindex_k >
	   *addressoflhscvbucketindex) {
    
    for(i=0;i<numberofdoubleforloopiterations;i++) {
      sDEBUGGING_CODE_1(RIGHT,
		       *addressofrhsvbucketindex_k,
		       *addressofunconsumedcurrentnonzerorange);
      sHOP_TO_NEXT_RHSVBUCKET(k,
			     addressofrhsvbucketindex_k,
			     rhsvectorconsumednonzeroranges_k,
			     rhsvectornonzeroranges_k);
      sDENSE_CONVERT_TO_c_LOOP(NEW_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     firstiterationloopsize,
				     addressofunconsumedcurrentnonzerorange);
      sDEBUGGING_CODE_1(LEFT,
		       *addressoflhscvbucketindex,
		       *addressofunconsumedcurrentnonzerorange);
      sget_and_hop_to_next_vbucket(addressoflhscvbucketindex);
      sDENSE_CONVERT_TO_c_LOOP(NEW_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     seconditerationloopsize,
				     addressofunconsumedcurrentnonzerorange);
    }
    
    if (remainder1loopsize > 0) {
      sDEBUGGING_CODE_1(RIGHT,
		       *addressofrhsvbucketindex_k,
		       *addressofunconsumedcurrentnonzerorange);
      sHOP_TO_NEXT_RHSVBUCKET(k,
			     addressofrhsvbucketindex_k,
			     rhsvectorconsumednonzeroranges_k,
			     rhsvectornonzeroranges_k);
      sDENSE_CONVERT_TO_c_LOOP(NEW_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     remainder1loopsize,
				     addressofunconsumedcurrentnonzerorange);
    }
    
    if (remainder2loopsize > 0) {
      sDEBUGGING_CODE_1(LEFT,
		       *addressoflhscvbucketindex,
		       *addressofunconsumedcurrentnonzerorange);
      sget_and_hop_to_next_vbucket(addressoflhscvbucketindex);
      sDENSE_CONVERT_TO_c_LOOP(NEW_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     remainder2loopsize,
				     addressofunconsumedcurrentnonzerorange);
    }
    DEBUGGING_CODE_2(*addressofunconsumedcurrentnonzerorange);
    if (rangedestination == COMPLETELY_NEW_RANGE) {
      *addressoflastlhscibucketindex = lhscibucketindex;
    }
  }
  
  
  /*********************************************
   * Case 3: rhssvbucket has same # of     *
   * spaces as lhscvbucket (i.e. 0).    *
   *********************************************/
  else if (*addressofrhsvbucketindex_k ==
	   *addressoflhscvbucketindex) {
    
    for(i=0;i<numberofdoubleforloopiterations;i++) {
      sDEBUGGING_CODE_1(LEFT,
		       *addressoflhscvbucketindex,
		       *addressofunconsumedcurrentnonzerorange);
      sget_and_hop_to_next_vbucket(addressoflhscvbucketindex);
      sHOP_TO_NEXT_RHSVBUCKET(k,
			     addressofrhsvbucketindex_k,
			     rhsvectorconsumednonzeroranges_k,
			     rhsvectornonzeroranges_k);
      sDENSE_CONVERT_TO_c_LOOP(NEW_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     firstiterationloopsize+seconditerationloopsize,
				     addressofunconsumedcurrentnonzerorange);
    }
    if (remainder1loopsize+remainder2loopsize > 0) {
      sDEBUGGING_CODE_1(LEFT,
		       *addressoflhscvbucketindex,
		       *addressofunconsumedcurrentnonzerorange);
      sget_and_hop_to_next_vbucket(addressoflhscvbucketindex);
      sHOP_TO_NEXT_RHSVBUCKET(k,
			     addressofrhsvbucketindex_k,
			     rhsvectorconsumednonzeroranges_k,
			     rhsvectornonzeroranges_k);
      sDENSE_CONVERT_TO_c_LOOP(NEW_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     remainder1loopsize+remainder2loopsize,
				     addressofunconsumedcurrentnonzerorange);
    }
    DEBUGGING_CODE_2(*addressofunconsumedcurrentnonzerorange);
    if (rangedestination == COMPLETELY_NEW_RANGE) {
      *addressoflastlhscibucketindex = lhscibucketindex;
    }
  }
}







/****************************************************************************
 *                                                                          *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/

void soverlapping_cs_range_convert_to_c(
			     addressoflhscvbucketindex,
			     k,
			     addressofrhsvbucketindex_k,
			     totalcurrentnonzerorange
#ifdef _DEBUG
			     ,addressofunconsumedcurrentnonzerorange
			     ,rhsvectorconsumednonzeroranges_k
			     ,rhsvectornonzeroranges_k
			     ,lhscvectornonzeroranges
#endif
			  )
int *addressoflhscvbucketindex;
int k;
int *addressofrhsvbucketindex_k;
int totalcurrentnonzerorange;
#ifdef _DEBUG
int *addressofunconsumedcurrentnonzerorange;
int rhsvectorconsumednonzeroranges_k;
int rhsvectornonzeroranges_k;
int lhscvectornonzeroranges;
#endif
{
  int firstloopsize;
  int numberofdoubleforloopiterations;
  int firstiterationloopsize;
  int seconditerationloopsize;
  int remainder1loopsize;
  int remainder2loopsize;

  int i;
  
  sDETERMINE_LOOP_BOUNDS(totalcurrentnonzerorange,
			*addressoflhscvbucketindex,
			*addressofrhsvbucketindex_k,
			&firstloopsize,
			&numberofdoubleforloopiterations,
			&firstiterationloopsize,
			&seconditerationloopsize,
			&remainder1loopsize,
			&remainder2loopsize,
			addressofunconsumedcurrentnonzerorange);
  sDENSE_CONVERT_TO_c_LOOP(OLD_RANGE,
				 addressoflhscvbucketindex,
				 addressofrhsvbucketindex_k,
				 k,
				 firstloopsize,
				 addressofunconsumedcurrentnonzerorange);
  
  
  /*********************************************
   * Case 1: rhssvbucket has more spaces   *
   *         remaining than lhscvbucket.*
   *********************************************/
  if (*addressofrhsvbucketindex_k <
      *addressoflhscvbucketindex) {
    /*B.2.1*/
    
    for(i=0;i<numberofdoubleforloopiterations;i++) { /*B.3.1*/
      sDEBUGGING_CODE_1(LEFT,
		       *addressoflhscvbucketindex,
		       *addressofunconsumedcurrentnonzerorange);
      sHOP_TO_NEXT_LHSVBUCKET(addressoflhscvbucketindex,
			     lhscvectornonzeroranges);
      sDENSE_CONVERT_TO_c_LOOP(OLD_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     firstiterationloopsize,
				     addressofunconsumedcurrentnonzerorange);
      sDEBUGGING_CODE_1(RIGHT,
		       *addressofrhsvbucketindex_k,
		       *addressofunconsumedcurrentnonzerorange);
      sHOP_TO_NEXT_RHSVBUCKET(k,
			     addressofrhsvbucketindex_k,
			     rhsvectorconsumednonzeroranges_k,
			     rhsvectornonzeroranges_k);
      sDENSE_CONVERT_TO_c_LOOP(OLD_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     seconditerationloopsize,
				     addressofunconsumedcurrentnonzerorange);
    } /*B.3.1*/
    
    if (remainder1loopsize > 0) {    	    
      sDEBUGGING_CODE_1(LEFT,
		       *addressoflhscvbucketindex,
		       *addressofunconsumedcurrentnonzerorange);
      sHOP_TO_NEXT_LHSVBUCKET(addressoflhscvbucketindex,
			     lhscvectornonzeroranges);
      sDENSE_CONVERT_TO_c_LOOP(OLD_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     remainder1loopsize,
				     addressofunconsumedcurrentnonzerorange);
    }
    
    if (remainder2loopsize > 0) {    
      sDEBUGGING_CODE_1(RIGHT,
		       *addressofrhsvbucketindex_k,
		       *addressofunconsumedcurrentnonzerorange);
      sHOP_TO_NEXT_RHSVBUCKET(k,
			     addressofrhsvbucketindex_k,
			     rhsvectorconsumednonzeroranges_k,
			     rhsvectornonzeroranges_k);
      sDENSE_CONVERT_TO_c_LOOP(OLD_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     remainder2loopsize,
				     addressofunconsumedcurrentnonzerorange);
    }
    DEBUGGING_CODE_2(*addressofunconsumedcurrentnonzerorange);
  } /*B.2.1*/
  
  /*********************************************
   * Case 2: rhssvbucket has less spaces   *
   * remaining than lhscvbucket.        *
   *********************************************/
  else if (*addressofrhsvbucketindex_k >
	   *addressoflhscvbucketindex) {
    /*B.2.2*/
    
    for(i=0;i<numberofdoubleforloopiterations;i++) { /*B.3.2*/
      sDEBUGGING_CODE_1(RIGHT,
		       *addressofrhsvbucketindex_k,
		       *addressofunconsumedcurrentnonzerorange);
      sHOP_TO_NEXT_RHSVBUCKET(k,
			     addressofrhsvbucketindex_k,
			     rhsvectorconsumednonzeroranges_k,
			     rhsvectornonzeroranges_k);
      sDENSE_CONVERT_TO_c_LOOP(OLD_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     firstiterationloopsize,
				     addressofunconsumedcurrentnonzerorange);
      sDEBUGGING_CODE_1(LEFT,
		       *addressoflhscvbucketindex,
		       *addressofunconsumedcurrentnonzerorange);
      sHOP_TO_NEXT_LHSVBUCKET(addressoflhscvbucketindex,
			     lhscvectornonzeroranges);
      sDENSE_CONVERT_TO_c_LOOP(OLD_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     seconditerationloopsize,
				     addressofunconsumedcurrentnonzerorange);
    } /*B.3.2*/
    
    if (remainder1loopsize > 0) {        
      sDEBUGGING_CODE_1(RIGHT,
		       *addressofrhsvbucketindex_k,
		       *addressofunconsumedcurrentnonzerorange);
      sHOP_TO_NEXT_RHSVBUCKET(k,
			     addressofrhsvbucketindex_k,
			     rhsvectorconsumednonzeroranges_k,
			     rhsvectornonzeroranges_k);
      sDENSE_CONVERT_TO_c_LOOP(OLD_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     remainder1loopsize,
				     addressofunconsumedcurrentnonzerorange);
    }
    if (remainder2loopsize > 0) {    
      sDEBUGGING_CODE_1(LEFT,
		       *addressoflhscvbucketindex,
		       *addressofunconsumedcurrentnonzerorange);
      sHOP_TO_NEXT_LHSVBUCKET(addressoflhscvbucketindex,
			     lhscvectornonzeroranges);
      sDENSE_CONVERT_TO_c_LOOP(OLD_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     remainder2loopsize,
				     addressofunconsumedcurrentnonzerorange);
    }
    DEBUGGING_CODE_2(*addressofunconsumedcurrentnonzerorange);
  } /*B.2.2*/
  
  
  /*********************************************
   * Case 3: rhssvbucket has same # of     *
   * spaces as lhscvbucket (i.e. 0).    *
   *********************************************/
  else if (*addressofrhsvbucketindex_k ==
	   *addressoflhscvbucketindex) {
    /*B.2.3*/
    
    for(i=0;i<numberofdoubleforloopiterations;i++) { /*B.3.3*/
      sDEBUGGING_CODE_1(LEFT,
		       *addressoflhscvbucketindex,
		       *addressofunconsumedcurrentnonzerorange);
      sHOP_TO_NEXT_LHSVBUCKET(addressoflhscvbucketindex,
			     lhscvectornonzeroranges);
      sHOP_TO_NEXT_RHSVBUCKET(k,
			     addressofrhsvbucketindex_k,
			     rhsvectorconsumednonzeroranges_k,
			     rhsvectornonzeroranges_k);
      sDENSE_CONVERT_TO_c_LOOP(OLD_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     firstiterationloopsize+seconditerationloopsize,
				     addressofunconsumedcurrentnonzerorange);
    } /*B.3.3*/
    
    if (remainder1loopsize+remainder2loopsize > 0) {    
      sDEBUGGING_CODE_1(LEFT,
		       *addressoflhscvbucketindex,
		       *addressofunconsumedcurrentnonzerorange);
      sHOP_TO_NEXT_LHSVBUCKET(addressoflhscvbucketindex,
			     lhscvectornonzeroranges);
      sHOP_TO_NEXT_RHSVBUCKET(k,
			     addressofrhsvbucketindex_k,
			     rhsvectorconsumednonzeroranges_k,
			     rhsvectornonzeroranges_k);
      sDENSE_CONVERT_TO_c_LOOP(OLD_RANGE,
				     addressoflhscvbucketindex,
				     addressofrhsvbucketindex_k,
				     k,
				     remainder1loopsize+remainder2loopsize,
				     addressofunconsumedcurrentnonzerorange);
    }
    DEBUGGING_CODE_2(*addressofunconsumedcurrentnonzerorange);
  } /*B.2.3*/
}




/****************************************************************************
 *                                                                          *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/

void sdense_convert_to_c_loop(range,
				    lhscvbucketindex,
				    rhssvbucketindex,
				    k,
				    loopsize
#ifdef _DEBUG
				    ,unconsumedcurrentnonzerorange
#endif
				    )
int range;
int *lhscvbucketindex;
int *rhssvbucketindex;
int k;
int loopsize;
#ifdef _DEBUG
int *unconsumedcurrentnonzerorange;
#endif
{
  int j;
  
  if (range == OLD_RANGE) {
    if (k == REAL_PART) {
      for (j=0;j<loopsize;j++)
	XY_PUT_AND_CAST_PLUS_EQUALS(lhscvbucketptr->
				    value[(*lhscvbucketindex)+j],
				    rhssvbucketptr[k]->
				    value[(*rhssvbucketindex)+j],
				    0,
				    float);
    }
    else {
      for (j=0;j<loopsize;j++)
	XY_PUT_AND_CAST_PLUS_EQUALS(lhscvbucketptr->
				    value[(*lhscvbucketindex)+j],
				    0,
				    rhssvbucketptr[k]->
				    value[(*rhssvbucketindex)+j],
				    float);
    }
  }
  else {
    if (k == REAL_PART) {
      for (j=0;j<loopsize;j++)
	XY_PUT_AND_CAST(lhscvbucketptr->
			value[(*lhscvbucketindex)+j],
			rhssvbucketptr[k]->
			value[(*rhssvbucketindex)+j],
			0,
			float);
    }
    else {
      for (j=0;j<loopsize;j++)
	XY_PUT_AND_CAST(lhscvbucketptr->
			value[(*lhscvbucketindex)+j],
			0,
			rhssvbucketptr[k]->
			value[(*rhssvbucketindex)+j],
			float);
    }
  }
  
  *lhscvbucketindex += loopsize;
  *rhssvbucketindex += loopsize;
  
#ifdef _DEBUG
  *unconsumedcurrentnonzerorange -= loopsize;
#endif
  
}



/****************************************************************************
 *                                                                          *
 *      sget_and_hop_to_next_to_c_vbucket(lhscvbucketindex)    *
 *                                                                          *
 *      Question: Why do we need this routine since a very similar routine  *
 *                exists called 'sget_and_hop_to_next_vbucket' which we      *
 *                instantiate with each precision?                          *
 *      Answer  : Because in the CALLs to these routines the globals        *
 *                lhsTO_pREc_vbucketptr and lhspREc_vbucketptr will be      *
 *                instantiated distinctly, even though the code for both    *
 *                these routines will be identical once instantiated.       *
 *                Note that once instantiated, both these names acquire     *
 *                a precision marker [s,d,c,z] in their name, depending on  *
 *                'TO_pREc_' and 'pREc_', respectively. (Uppercase and      *
 *                lowercase letters in both these names have been           *
 *                permutated so that this comment would be preserved as is  *
 *                after instantiation.  Here, by instantiation we mean the  *
 *                result of macro expansion.)                               *  
 *                                                                          *
 ****************************************************************************/

void sget_and_hop_to_next_to_c_vbucket(lhscvbucketindex)
int *lhscvbucketindex;
{
  cgetvbucket(&(lhscvbucketptr->nextvbucket));
  lhscvbucketptr = lhscvbucketptr->nextvbucket;
  *lhscvbucketindex = 0;
}




/****************************************************************************
 *                                                                          *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/
void saxpy_2_heap_to_c_post_processing(destptrptr,
					     rhssvectorptrptrs,
					     restorerhssvectorptr,
					     arity,
					     lhscvectornonzeroes,
					     lhscvectornonzeroranges,
					     governingdstype)
cvectorstruct **destptrptr;
svectorstruct **rhssvectorptrptrs[];
svectorstruct *restorerhssvectorptr[MAXARITY+1];
int arity;
int lhscvectornonzeroes;
int lhscvectornonzeroranges;
int governingdstype;
{
  svectorstruct *rhssvectorptr[MAXARITY];

  cvectorstruct *tempcvectorptr;
  cvectorstruct *sstempcvectorptr;
  cbucketstruct *tempcbucketptr;
  cbucketstruct *sstempcbucketptr;
  cibucketstruct *tempcibucketptr;
  cvbucketstruct *tempcvbucketptr;

  svectorstruct *tempsvectorptr;
  sbucketstruct *tempsbucketptr;
  sibucketstruct *tempsibucketptr;
  svbucketstruct *tempsvbucketptr;

  int k;

  for (k=0;k<arity;k++)
    rhssvectorptr[k] = *rhssvectorptrptrs[k];

  /****************************************
   * Switch lhscvectorptr and *destptrptr. *
   ****************************************/

  lhscvectorptr->nonzeroes = lhscvectornonzeroes;
  
  if (governingdstype == CS)
    lhscvectorptr->cds.cs.nonzeroranges =
      lhscvectornonzeroranges;
  
  tempcvectorptr = (*destptrptr);
  (*destptrptr) = lhscvectorptr;
  lhscvectorptr = tempcvectorptr;

  if (governingdstype == SS) {
    
    if ((INITIALIZED_MAXINDEX &&
	 ((float) (*destptrptr)->nonzeroes / (float) GLOBAL_MAXINDEX) >=
	 SWITCH_NZ_RATIO)     ||
	((*destptrptr)->nonzeroes >= SWITCH_NZ_VALUE)) {
             
      /****************************************
       * Convert SS to CS.                    *
       ****************************************/
      
      sstempcvectorptr = (*destptrptr);
      cconvertdstype(destptrptr,MAXARITY,CS);
	  
      sstempcbucketptr =
	sstempcvectorptr->cds.ss.bucketptr;
      if (sstempcbucketptr != NULL) {
	while (sstempcbucketptr->nextbucket != NULL)
	  sstempcbucketptr = sstempcbucketptr->nextbucket;
	sstempcbucketptr->nextbucket = freedcbucketslist;
	RESET_freedcbucketslist(sstempcvectorptr->cds.ss.bucketptr);
	sstempcvectorptr->cds.ss.bucketptr = NULL;
      }
      holdingbincvectorptr[MAXARITY] =  sstempcvectorptr;
    }
  }
  
  /****************************************
   * If *destptrptr was not empty,        *
   * add its buckets to freedcbucketslist. *
   ****************************************/
  
  if (tempcvectorptr->dstype == SS) {
    tempcbucketptr = tempcvectorptr->cds.ss.bucketptr;
    if (tempcbucketptr != NULL) {
      while (tempcbucketptr->nextbucket != NULL)
	tempcbucketptr = tempcbucketptr->nextbucket;
      tempcbucketptr->nextbucket = freedcbucketslist;
      RESET_freedcbucketslist(tempcvectorptr->cds.ss.bucketptr);
      tempcvectorptr->cds.ss.bucketptr = NULL;
    }
  }
  else if (tempcvectorptr->dstype == CS) {
    tempcibucketptr = tempcvectorptr->cds.cs.ibucketptr;
    if (tempcibucketptr != NULL) {
      while (tempcibucketptr->nextibucket != NULL)
	tempcibucketptr = tempcibucketptr->nextibucket;
      tempcibucketptr->nextibucket = freedcibucketslist;
      RESET_freedcibucketslist(tempcvectorptr->cds.cs.ibucketptr);
      tempcvectorptr->cds.cs.ibucketptr = NULL;
    }
    tempcvbucketptr = tempcvectorptr->cds.cs.vbucketptr;
    if (tempcvbucketptr != NULL) {
      while (tempcvbucketptr->nextvbucket != NULL)
	tempcvbucketptr = tempcvbucketptr->nextvbucket;
      tempcvbucketptr->nextvbucket = freedcvbucketslist;
      RESET_freedcvbucketslist(tempcvectorptr->cds.cs.vbucketptr);
      tempcvectorptr->cds.cs.vbucketptr = NULL;
    }
  }
  
  /*****************************************
   * If holdingbins were used, add         *
   * their buckets to freedsbucketslist, OR *
   * their ibuckets to freedsibucketslist & *
   * their vbuckets to freedsvbucketslist.  *
   *****************************************/
  for (k=0;k<arity;k++) {
    
    rhssvectorptr[k] = restorerhssvectorptr[k];
    
    if (holdingbinsvectorptr[k]->dstype == SS) {
      tempsbucketptr = holdingbinsvectorptr[k]->sds.ss.bucketptr;
      if (tempsbucketptr != NULL) {
#ifdef _DEBUG
	if (governingdstype == CS) {
	  printf("sspgx warning 7.4: Unexpcted non-NULL");
	  printf("tempsbucketptr.\n");
	}
#endif
	while (tempsbucketptr->nextbucket != NULL) {
#ifdef _DEBUG
	  if (governingdstype == SS) {
	    printf("sspgx warning 7.1: tempsbucketptr should have");
	    printf(" no trailing nextbuckets\n");
	  }
#endif
	  tempsbucketptr = tempsbucketptr->nextbucket;
	}
	tempsbucketptr->nextbucket = freedsbucketslist;
	RESET_freedsbucketslist(holdingbinsvectorptr[k]->sds.ss.bucketptr);
	holdingbinsvectorptr[k]->sds.ss.bucketptr = NULL;
      }
    }
    else if (holdingbinsvectorptr[k]->dstype == CS) {
      tempsibucketptr =
	holdingbinsvectorptr[k]->sds.cs.ibucketptr;
      if (tempsibucketptr != NULL) {
#ifdef _DEBUG
	if (governingdstype == SS) {
	  printf("sspgx warning 7.2: Unexpcted non-NULL");
	  printf(" ibucketptr.\n");
	}
#endif
	while (tempsibucketptr->nextibucket != NULL)
	  tempsibucketptr = tempsibucketptr->nextibucket;
	tempsibucketptr->nextibucket = freedsibucketslist;
	RESET_freedsibucketslist(holdingbinsvectorptr[k]->sds.cs.ibucketptr);
	holdingbinsvectorptr[k]->sds.cs.ibucketptr = NULL;
      }
      tempsvbucketptr =
	holdingbinsvectorptr[k]->sds.cs.vbucketptr;
      if (tempsvbucketptr != NULL) {
#ifdef _DEBUG
	if (governingdstype == SS) {
	  printf("sspgx warning 7.3: Unexpcted non-NULL");
	  printf(" vbucketptr.\n");
	}
#endif
	while (tempsvbucketptr->nextvbucket != NULL)
	  tempsvbucketptr = tempsvbucketptr->nextvbucket;
	tempsvbucketptr->nextvbucket = freedsvbucketslist;
	RESET_freedsvbucketslist(holdingbinsvectorptr[k]->sds.cs.vbucketptr);
	holdingbinsvectorptr[k]->sds.cs.vbucketptr = NULL;
      }
    }
  } /* matches    for (k=0;k<arity;k++) {    */
}

