CC------------------------------------------------------------------CC
CC (C) COPYRIGHT 1994 University of Chicago                         CC
CC                                                                  CC
CC THIS PROGRAM DISCLOSES MATERIAL PROTECTABLE UNDER COPYRIGHT      CC
CC LAWS OF THE UNITED STATES. USE IS PERMITTED WITHOUT FEE FOR      CC
CC EDUCATION AND NON-PROFIT RESEARCH PURPOSES SUBJECT TO THE        CC
CC TERMS OF A LICENSE DISTRIBUTED WITH THE ADIFOR 2.0 SOFTWARE      CC
CC AND AVAILABLE AT:                                                CC
CC http://www.mcs.anl.gov/autodiff/adifor_license.html, or          CC
CC http://www.cs.rice.edu/fortran-tools/ADIFOR/adifor_license.html. CC
CC ANY ENTITY DESIRING PERMISSION TO INCORPORATE THIS SOFTWARE      CC
CC OR A WORK BASED ON THE SOFTWARE INTO COMMERCIAL PRODUCTS OR      CC
CC OTHERWISE USE IT FOR COMMERCIAL PURPOSES SHOULD CONTACT:         CC
CC                                                                  CC
CC Paul Hovland, Mathematics and Computer Science Division,         CC
CC Argonne National Laboratory, 9700 S. Cass Avenue, Argonne IL     CC
CC 60439, hovland@mcs.anl.gov.                                     CC
CC                                                                  CC
CC Alan Carle, Center for Research on Parallel Computation, Rice    CC
CC University MS 41, 6100 S. Main Street, Houston, TX 77251-1892,   CC
CC carle@cs.rice.edu.                                               CC
CC------------------------------------------------------------------CC


C*************************************************************************
C                                                                        *
      SUBROUTINE xsprhs (line,file,arity_order)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose reporting,    *
C       of uninitialized right-hand side vectors.                        *
C                                                                        *
C*************************************************************************

      INTEGER            line
      CHARACTER*(*)       file
      INTEGER            arity_order
      CHARACTER*2        eth

      IF (arity_order .eq. 1) THEN
        eth = 'st'
      ELSEIF (arity_order .eq. 2) THEN
        eth = 'nd'
      ELSEIF (arity_order .eq. 3) THEN
        eth = 'rd'
      ELSE
        eth = 'th'
      ENDIF
      WRITE(*,10) arity_order,eth,line,file
 10   FORMAT('SparsLinC warning : Non_initialized vector on the rhs:',/,
     *       '   The ',i1,a2,' rhsvector on line ',i5,' of ',a,/)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspzro (DESTPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for sspzro                    *
C                                                                        *
C*************************************************************************

      INTEGER             DESTPTR

      CALL sspzronotca (DESTPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspzro (DESTPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for dspzro                    *
C                                                                        *
C*************************************************************************

      INTEGER             DESTPTR

      CALL dspzronotca (DESTPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspzro (DESTPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for cspzro                    *
C                                                                        *
C*************************************************************************

      INTEGER             DESTPTR

      CALL cspzronotca (DESTPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspzro (DESTPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for zspzro                    *
C                                                                        *
C*************************************************************************

      INTEGER             DESTPTR

      CALL zspzronotca (DESTPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspprv (VPTR,UNIT,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of sppr  ( PRINT   ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            VPTR
      INTEGER            UNIT
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (VPTR)
      END IF

      CALL ssppr (VPTR,UNIT)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspprv (VPTR,UNIT,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of sppr  ( PRINT   ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            VPTR
      INTEGER            UNIT
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (VPTR)
      END IF

      CALL dsppr (VPTR,UNIT)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspprv (VPTR,UNIT,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of sppr  ( PRINT   ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            VPTR
      INTEGER            UNIT
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (VPTR)
      END IF

      CALL csppr (VPTR,UNIT)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspprv (VPTR,UNIT,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of sppr  ( PRINT   ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            VPTR
      INTEGER            UNIT
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (VPTR)
      END IF

      CALL zsppr (VPTR,UNIT)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspprq (VPTR,UNIT)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of sppr  ( PRINT   ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            VPTR
      INTEGER            UNIT

      IF (VPTR .EQ. 0) THEN
        CALL sspzronotca (VPTR)
      END IF

      CALL ssppr (VPTR,UNIT)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspprq (VPTR,UNIT)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of sppr  ( PRINT   ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            VPTR
      INTEGER            UNIT

      IF (VPTR .EQ. 0) THEN
        CALL dspzronotca (VPTR)
      END IF

      CALL dsppr (VPTR,UNIT)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspprq (VPTR,UNIT)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of sppr  ( PRINT   ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            VPTR
      INTEGER            UNIT

      IF (VPTR .EQ. 0) THEN
        CALL cspzronotca (VPTR)
      END IF

      CALL csppr (VPTR,UNIT)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspprq (VPTR,UNIT)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of sppr  ( PRINT   ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            VPTR
      INTEGER            UNIT

      IF (VPTR .EQ. 0) THEN
        CALL zspzronotca (VPTR)
      END IF

      CALL zsppr (VPTR,UNIT)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspxdv (XVEC,LENX,VPTR,LENV,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of spxd  ( X_DENSE ).                   *
C                                                                        *
C*************************************************************************

      REAL               XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (VPTR)
      END IF

      CALL sspxd (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspxdv (XVEC,LENX,VPTR,LENV,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of spxd  ( X_DENSE ).                   *
C                                                                        *
C*************************************************************************

      DOUBLE PRECISION   XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (VPTR)
      END IF

      CALL dspxd (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspxdv (XVEC,LENX,VPTR,LENV,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of spxd  ( X_DENSE ).                   *
C                                                                        *
C*************************************************************************

      COMPLEX            XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (VPTR)
      END IF

      CALL cspxd (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspxdv (XVEC,LENX,VPTR,LENV,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of spxd  ( X_DENSE ).                   *
C                                                                        *
C*************************************************************************

      DOUBLE COMPLEX     XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (VPTR)
      END IF

      CALL zspxd (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspxdq (XVEC,LENX,VPTR,LENV,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of spxd  ( X_DENSE ).                   *
C                                                                        *
C*************************************************************************

      REAL               XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL sspzronotca (VPTR)
      END IF

      CALL sspxd (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspxdq (XVEC,LENX,VPTR,LENV,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of spxd  ( X_DENSE ).                   *
C                                                                        *
C*************************************************************************

      DOUBLE PRECISION   XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL dspzronotca (VPTR)
      END IF

      CALL dspxd (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspxdq (XVEC,LENX,VPTR,LENV,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of spxd  ( X_DENSE ).                   *
C                                                                        *
C*************************************************************************

      COMPLEX            XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL cspzronotca (VPTR)
      END IF

      CALL cspxd (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspxdq (XVEC,LENX,VPTR,LENV,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of spxd  ( X_DENSE ).                   *
C                                                                        *
C*************************************************************************

      DOUBLE COMPLEX     XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL zspzronotca (VPTR)
      END IF

      CALL zspxd (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspxsv (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of spxs  ( X_SPARSE).                   *
C                                                                        *
C*************************************************************************

      INTEGER   INDVEC (LENV)
      INTEGER   VALVEC (LENV)
      INTEGER            LENV
      INTEGER            VPTR
      INTEGER            NONZ
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (VPTR)
      END IF

      CALL sspxs (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspxsv (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of spxs  ( X_SPARSE).                   *
C                                                                        *
C*************************************************************************

      INTEGER   INDVEC (LENV)
      INTEGER   VALVEC (LENV)
      INTEGER            LENV
      INTEGER            VPTR
      INTEGER            NONZ
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (VPTR)
      END IF

      CALL dspxs (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspxsv (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of spxs  ( X_SPARSE).                   *
C                                                                        *
C*************************************************************************

      INTEGER   INDVEC (LENV)
      INTEGER   VALVEC (LENV)
      INTEGER            LENV
      INTEGER            VPTR
      INTEGER            NONZ
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (VPTR)
      END IF

      CALL cspxs (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspxsv (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of spxs  ( X_SPARSE).                   *
C                                                                        *
C*************************************************************************

      INTEGER   INDVEC (LENV)
      INTEGER   VALVEC (LENV)
      INTEGER            LENV
      INTEGER            VPTR
      INTEGER            NONZ
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (VPTR)
      END IF

      CALL zspxs (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspxsq (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of spxs  ( X_SPARSE).                   *
C                                                                        *
C*************************************************************************

      INTEGER   INDVEC (LENV)
      INTEGER   VALVEC (LENV)
      INTEGER            LENV
      INTEGER            VPTR
      INTEGER            NONZ
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL sspzronotca (VPTR)
      END IF

      CALL sspxs (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspxsq (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of spxs  ( X_SPARSE).                   *
C                                                                        *
C*************************************************************************

      INTEGER   INDVEC (LENV)
      INTEGER   VALVEC (LENV)
      INTEGER            LENV
      INTEGER            VPTR
      INTEGER            NONZ
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL dspzronotca (VPTR)
      END IF

      CALL dspxs (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspxsq (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of spxs  ( X_SPARSE).                   *
C                                                                        *
C*************************************************************************

      INTEGER   INDVEC (LENV)
      INTEGER   VALVEC (LENV)
      INTEGER            LENV
      INTEGER            VPTR
      INTEGER            NONZ
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL cspzronotca (VPTR)
      END IF

      CALL cspxs (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspxsq (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of spxs  ( X_SPARSE).                   *
C                                                                        *
C*************************************************************************

      INTEGER   INDVEC (LENV)
      INTEGER   VALVEC (LENV)
      INTEGER            LENV
      INTEGER            VPTR
      INTEGER            NONZ
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL zspzronotca (VPTR)
      END IF

      CALL zspxs (INDVEC,VALVEC,LENV,VPTR,NONZ,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspxmv (XVEC,LENX,MULT,VPTR,LENV,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of spxm  ( X_MULT_ADD ).                   *
C                                                                        *
C*************************************************************************

      REAL               XVEC (LENX)
      INTEGER            LENX
      REAL               MULT
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (VPTR)
      END IF

      CALL sspxm (XVEC,LENX,MULT,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspxmv (XVEC,LENX,MULT,VPTR,LENV,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of spxm  ( X_MULT_ADD ).                   *
C                                                                        *
C*************************************************************************

      DOUBLE PRECISION   XVEC (LENX)
      INTEGER            LENX
      DOUBLE PRECISION   MULT
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (VPTR)
      END IF

      CALL dspxm (XVEC,LENX,MULT,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspxmv (XVEC,LENX,MULT,VPTR,LENV,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of spxm  ( X_MULT_ADD ).                   *
C                                                                        *
C*************************************************************************

      COMPLEX            XVEC (LENX)
      INTEGER            LENX
      COMPLEX            MULT
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (VPTR)
      END IF

      CALL cspxm (XVEC,LENX,MULT,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspxmv (XVEC,LENX,MULT,VPTR,LENV,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of spxm  ( X_MULT_ADD ).                   *
C                                                                        *
C*************************************************************************

      DOUBLE COMPLEX     XVEC (LENX)
      INTEGER            LENX
      DOUBLE COMPLEX     MULT
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (VPTR)
      END IF

      CALL zspxm (XVEC,LENX,MULT,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspxmq (XVEC,LENX,MULT,VPTR,LENV,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of spxm  ( X_MULT_ADD ).                   *
C                                                                        *
C*************************************************************************

      REAL               XVEC (LENX)
      INTEGER            LENX
      REAL               MULT
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL sspzronotca (VPTR)
      END IF

      CALL sspxm (XVEC,LENX,MULT,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspxmq (XVEC,LENX,MULT,VPTR,LENV,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of spxm  ( X_MULT_ADD ).                   *
C                                                                        *
C*************************************************************************

      DOUBLE PRECISION   XVEC (LENX)
      INTEGER            LENX
      DOUBLE PRECISION   MULT
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL dspzronotca (VPTR)
      END IF

      CALL dspxm (XVEC,LENX,MULT,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspxmq (XVEC,LENX,MULT,VPTR,LENV,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of spxm  ( X_MULT_ADD ).                   *
C                                                                        *
C*************************************************************************

      COMPLEX            XVEC (LENX)
      INTEGER            LENX
      COMPLEX            MULT
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL cspzronotca (VPTR)
      END IF

      CALL cspxm (XVEC,LENX,MULT,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspxmq (XVEC,LENX,MULT,VPTR,LENV,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of spxm  ( X_MULT_ADD ).                   *
C                                                                        *
C*************************************************************************

      DOUBLE COMPLEX     XVEC (LENX)
      INTEGER            LENX
      DOUBLE COMPLEX     MULT
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL zspzronotca (VPTR)
      END IF

      CALL zspxm (XVEC,LENX,MULT,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspxav (XVEC,LENX,VPTR,LENV,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of spxa  ( X_ADD ).                   *
C                                                                        *
C*************************************************************************

      REAL               XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (VPTR)
      END IF

      CALL sspxa (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspxav (XVEC,LENX,VPTR,LENV,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of spxa  ( X_ADD ).                   *
C                                                                        *
C*************************************************************************

      DOUBLE PRECISION   XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (VPTR)
      END IF

      CALL dspxa (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspxav (XVEC,LENX,VPTR,LENV,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of spxa  ( X_ADD ).                   *
C                                                                        *
C*************************************************************************

      COMPLEX            XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (VPTR)
      END IF

      CALL cspxa (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspxav (XVEC,LENX,VPTR,LENV,INFO,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of spxa  ( X_ADD ).                   *
C                                                                        *
C*************************************************************************

      DOUBLE COMPLEX     XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (VPTR)
      END IF

      CALL zspxa (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspxaq (XVEC,LENX,VPTR,LENV,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of spxa  ( X_ADD ).                   *
C                                                                        *
C*************************************************************************

      REAL               XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL sspzronotca (VPTR)
      END IF

      CALL sspxa (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspxaq (XVEC,LENX,VPTR,LENV,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of spxa  ( X_ADD ).                   *
C                                                                        *
C*************************************************************************

      DOUBLE PRECISION   XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL dspzronotca (VPTR)
      END IF

      CALL dspxa (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspxaq (XVEC,LENX,VPTR,LENV,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of spxa  ( X_ADD ).                   *
C                                                                        *
C*************************************************************************

      COMPLEX            XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL cspzronotca (VPTR)
      END IF

      CALL cspxa (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspxaq (XVEC,LENX,VPTR,LENV,INFO)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of spxa  ( X_ADD ).                   *
C                                                                        *
C*************************************************************************

      DOUBLE COMPLEX     XVEC (LENX)
      INTEGER            LENX
      INTEGER            VPTR
      INTEGER            LENV
      INTEGER            INFO

      IF (VPTR .EQ. 0) THEN
        CALL zspzronotca (VPTR)
      END IF

      CALL zspxa (XVEC,LENX,VPTR,LENV,INFO)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspcpv (DESTPTR,SRCPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of spcp  ( COPY    ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            SRCPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (SRCPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (SRCPTR)
      END IF

      CALL sspcp (DESTPTR,SRCPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspcpv (DESTPTR,SRCPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of spcp  ( COPY    ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            SRCPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (SRCPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (SRCPTR)
      END IF

      CALL dspcp (DESTPTR,SRCPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspcpv (DESTPTR,SRCPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of spcp  ( COPY    ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            SRCPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (SRCPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (SRCPTR)
      END IF

      CALL cspcp (DESTPTR,SRCPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspcpv (DESTPTR,SRCPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of spcp  ( COPY    ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            SRCPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (SRCPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (SRCPTR)
      END IF

      CALL zspcp (DESTPTR,SRCPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspcpq (DESTPTR,SRCPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of spcp  ( COPY    ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            SRCPTR

      IF (SRCPTR .EQ. 0) THEN
        CALL sspzronotca (SRCPTR)
      END IF

      CALL sspcp (DESTPTR,SRCPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspcpq (DESTPTR,SRCPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of spcp  ( COPY    ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            SRCPTR

      IF (SRCPTR .EQ. 0) THEN
        CALL dspzronotca (SRCPTR)
      END IF

      CALL dspcp (DESTPTR,SRCPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspcpq (DESTPTR,SRCPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of spcp  ( COPY    ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            SRCPTR

      IF (SRCPTR .EQ. 0) THEN
        CALL cspzronotca (SRCPTR)
      END IF

      CALL cspcp (DESTPTR,SRCPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspcpq (DESTPTR,SRCPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of spcp  ( COPY    ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            SRCPTR

      IF (SRCPTR .EQ. 0) THEN
        CALL zspzronotca (SRCPTR)
      END IF

      CALL zspcp (DESTPTR,SRCPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspg1v (DESTPTR,ALPHA1,V1PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of spg1  ( GAXPY 1 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      REAL               ALPHA1
      INTEGER            V1PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (V1PTR)
      END IF

      CALL sspg1 (DESTPTR,ALPHA1,V1PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspg1v (DESTPTR,ALPHA1,V1PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of spg1  ( GAXPY 1 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE PRECISION   ALPHA1
      INTEGER            V1PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (V1PTR)
      END IF

      CALL dspg1 (DESTPTR,ALPHA1,V1PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspg1v (DESTPTR,ALPHA1,V1PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of spg1  ( GAXPY 1 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      COMPLEX            ALPHA1
      INTEGER            V1PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (V1PTR)
      END IF

      CALL cspg1 (DESTPTR,ALPHA1,V1PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspg1v (DESTPTR,ALPHA1,V1PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of spg1  ( GAXPY 1 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE COMPLEX     ALPHA1
      INTEGER            V1PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (V1PTR)
      END IF

      CALL zspg1 (DESTPTR,ALPHA1,V1PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspg1q (DESTPTR,ALPHA1,V1PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of spg1  ( GAXPY 1 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      REAL               ALPHA1
      INTEGER            V1PTR

      IF (V1PTR .EQ. 0) THEN
        CALL sspzronotca (V1PTR)
      END IF

      CALL sspg1 (DESTPTR,ALPHA1,V1PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspg1q (DESTPTR,ALPHA1,V1PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of spg1  ( GAXPY 1 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE PRECISION   ALPHA1
      INTEGER            V1PTR

      IF (V1PTR .EQ. 0) THEN
        CALL dspzronotca (V1PTR)
      END IF

      CALL dspg1 (DESTPTR,ALPHA1,V1PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspg1q (DESTPTR,ALPHA1,V1PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of spg1  ( GAXPY 1 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      COMPLEX            ALPHA1
      INTEGER            V1PTR

      IF (V1PTR .EQ. 0) THEN
        CALL cspzronotca (V1PTR)
      END IF

      CALL cspg1 (DESTPTR,ALPHA1,V1PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspg1q (DESTPTR,ALPHA1,V1PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of spg1  ( GAXPY 1 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE COMPLEX     ALPHA1
      INTEGER            V1PTR

      IF (V1PTR .EQ. 0) THEN
        CALL zspzronotca (V1PTR)
      END IF

      CALL zspg1 (DESTPTR,ALPHA1,V1PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspg2v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of spg2  ( GAXPY 2 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      REAL               ALPHA1
      INTEGER            V1PTR
      REAL               ALPHA2
      INTEGER            V2PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL sspzronotca (V2PTR)
      END IF

      CALL sspg2 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspg2v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of spg2  ( GAXPY 2 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE PRECISION   ALPHA1
      INTEGER            V1PTR
      DOUBLE PRECISION   ALPHA2
      INTEGER            V2PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL dspzronotca (V2PTR)
      END IF

      CALL dspg2 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspg2v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of spg2  ( GAXPY 2 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      COMPLEX            ALPHA1
      INTEGER            V1PTR
      COMPLEX            ALPHA2
      INTEGER            V2PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL cspzronotca (V2PTR)
      END IF

      CALL cspg2 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspg2v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of spg2  ( GAXPY 2 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE COMPLEX     ALPHA1
      INTEGER            V1PTR
      DOUBLE COMPLEX     ALPHA2
      INTEGER            V2PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL zspzronotca (V2PTR)
      END IF

      CALL zspg2 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspg2q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of spg2  ( GAXPY 2 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      REAL               ALPHA1
      INTEGER            V1PTR
      REAL               ALPHA2
      INTEGER            V2PTR

      IF (V1PTR .EQ. 0) THEN
        CALL sspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL sspzronotca (V2PTR)
      END IF

      CALL sspg2 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspg2q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of spg2  ( GAXPY 2 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE PRECISION   ALPHA1
      INTEGER            V1PTR
      DOUBLE PRECISION   ALPHA2
      INTEGER            V2PTR

      IF (V1PTR .EQ. 0) THEN
        CALL dspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL dspzronotca (V2PTR)
      END IF

      CALL dspg2 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspg2q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of spg2  ( GAXPY 2 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      COMPLEX            ALPHA1
      INTEGER            V1PTR
      COMPLEX            ALPHA2
      INTEGER            V2PTR

      IF (V1PTR .EQ. 0) THEN
        CALL cspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL cspzronotca (V2PTR)
      END IF

      CALL cspg2 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspg2q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of spg2  ( GAXPY 2 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE COMPLEX     ALPHA1
      INTEGER            V1PTR
      DOUBLE COMPLEX     ALPHA2
      INTEGER            V2PTR

      IF (V1PTR .EQ. 0) THEN
        CALL zspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL zspzronotca (V2PTR)
      END IF

      CALL zspg2 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspg3v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of spg3  ( GAXPY 3 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      REAL               ALPHA1
      INTEGER            V1PTR
      REAL               ALPHA2
      INTEGER            V2PTR
      REAL               ALPHA3
      INTEGER            V3PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL sspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL xsprhs (line,file,3)
        CALL sspzronotca (V3PTR)
      END IF

      CALL sspg3 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspg3v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of spg3  ( GAXPY 3 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE PRECISION   ALPHA1
      INTEGER            V1PTR
      DOUBLE PRECISION   ALPHA2
      INTEGER            V2PTR
      DOUBLE PRECISION   ALPHA3
      INTEGER            V3PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL dspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL xsprhs (line,file,3)
        CALL dspzronotca (V3PTR)
      END IF

      CALL dspg3 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspg3v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of spg3  ( GAXPY 3 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      COMPLEX            ALPHA1
      INTEGER            V1PTR
      COMPLEX            ALPHA2
      INTEGER            V2PTR
      COMPLEX            ALPHA3
      INTEGER            V3PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL cspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL xsprhs (line,file,3)
        CALL cspzronotca (V3PTR)
      END IF

      CALL cspg3 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspg3v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of spg3  ( GAXPY 3 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE COMPLEX     ALPHA1
      INTEGER            V1PTR
      DOUBLE COMPLEX     ALPHA2
      INTEGER            V2PTR
      DOUBLE COMPLEX     ALPHA3
      INTEGER            V3PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL zspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL xsprhs (line,file,3)
        CALL zspzronotca (V3PTR)
      END IF

      CALL zspg3 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspg3q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of spg3  ( GAXPY 3 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      REAL               ALPHA1
      INTEGER            V1PTR
      REAL               ALPHA2
      INTEGER            V2PTR
      REAL               ALPHA3
      INTEGER            V3PTR

      IF (V1PTR .EQ. 0) THEN
        CALL sspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL sspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL sspzronotca (V3PTR)
      END IF

      CALL sspg3 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspg3q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of spg3  ( GAXPY 3 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE PRECISION   ALPHA1
      INTEGER            V1PTR
      DOUBLE PRECISION   ALPHA2
      INTEGER            V2PTR
      DOUBLE PRECISION   ALPHA3
      INTEGER            V3PTR

      IF (V1PTR .EQ. 0) THEN
        CALL dspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL dspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL dspzronotca (V3PTR)
      END IF

      CALL dspg3 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspg3q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of spg3  ( GAXPY 3 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      COMPLEX            ALPHA1
      INTEGER            V1PTR
      COMPLEX            ALPHA2
      INTEGER            V2PTR
      COMPLEX            ALPHA3
      INTEGER            V3PTR

      IF (V1PTR .EQ. 0) THEN
        CALL cspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL cspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL cspzronotca (V3PTR)
      END IF

      CALL cspg3 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspg3q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of spg3  ( GAXPY 3 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE COMPLEX     ALPHA1
      INTEGER            V1PTR
      DOUBLE COMPLEX     ALPHA2
      INTEGER            V2PTR
      DOUBLE COMPLEX     ALPHA3
      INTEGER            V3PTR

      IF (V1PTR .EQ. 0) THEN
        CALL zspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL zspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL zspzronotca (V3PTR)
      END IF

      CALL zspg3 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspg4v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of spg4  ( GAXPY 4 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      REAL               ALPHA1
      INTEGER            V1PTR
      REAL               ALPHA2
      INTEGER            V2PTR
      REAL               ALPHA3
      INTEGER            V3PTR
      REAL               ALPHA4
      INTEGER            V4PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL sspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL xsprhs (line,file,3)
        CALL sspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL xsprhs (line,file,4)
        CALL sspzronotca (V4PTR)
      END IF

      CALL sspg4 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspg4v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of spg4  ( GAXPY 4 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE PRECISION   ALPHA1
      INTEGER            V1PTR
      DOUBLE PRECISION   ALPHA2
      INTEGER            V2PTR
      DOUBLE PRECISION   ALPHA3
      INTEGER            V3PTR
      DOUBLE PRECISION   ALPHA4
      INTEGER            V4PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL dspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL xsprhs (line,file,3)
        CALL dspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL xsprhs (line,file,4)
        CALL dspzronotca (V4PTR)
      END IF

      CALL dspg4 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspg4v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of spg4  ( GAXPY 4 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      COMPLEX            ALPHA1
      INTEGER            V1PTR
      COMPLEX            ALPHA2
      INTEGER            V2PTR
      COMPLEX            ALPHA3
      INTEGER            V3PTR
      COMPLEX            ALPHA4
      INTEGER            V4PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL cspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL xsprhs (line,file,3)
        CALL cspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL xsprhs (line,file,4)
        CALL cspzronotca (V4PTR)
      END IF

      CALL cspg4 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspg4v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of spg4  ( GAXPY 4 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE COMPLEX     ALPHA1
      INTEGER            V1PTR
      DOUBLE COMPLEX     ALPHA2
      INTEGER            V2PTR
      DOUBLE COMPLEX     ALPHA3
      INTEGER            V3PTR
      DOUBLE COMPLEX     ALPHA4
      INTEGER            V4PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL zspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL xsprhs (line,file,3)
        CALL zspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL xsprhs (line,file,4)
        CALL zspzronotca (V4PTR)
      END IF

      CALL zspg4 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspg4q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of spg4  ( GAXPY 4 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      REAL               ALPHA1
      INTEGER            V1PTR
      REAL               ALPHA2
      INTEGER            V2PTR
      REAL               ALPHA3
      INTEGER            V3PTR
      REAL               ALPHA4
      INTEGER            V4PTR

      IF (V1PTR .EQ. 0) THEN
        CALL sspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL sspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL sspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL sspzronotca (V4PTR)
      END IF

      CALL sspg4 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspg4q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of spg4  ( GAXPY 4 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE PRECISION   ALPHA1
      INTEGER            V1PTR
      DOUBLE PRECISION   ALPHA2
      INTEGER            V2PTR
      DOUBLE PRECISION   ALPHA3
      INTEGER            V3PTR
      DOUBLE PRECISION   ALPHA4
      INTEGER            V4PTR

      IF (V1PTR .EQ. 0) THEN
        CALL dspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL dspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL dspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL dspzronotca (V4PTR)
      END IF

      CALL dspg4 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspg4q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of spg4  ( GAXPY 4 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      COMPLEX            ALPHA1
      INTEGER            V1PTR
      COMPLEX            ALPHA2
      INTEGER            V2PTR
      COMPLEX            ALPHA3
      INTEGER            V3PTR
      COMPLEX            ALPHA4
      INTEGER            V4PTR

      IF (V1PTR .EQ. 0) THEN
        CALL cspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL cspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL cspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL cspzronotca (V4PTR)
      END IF

      CALL cspg4 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspg4q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of spg4  ( GAXPY 4 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE COMPLEX     ALPHA1
      INTEGER            V1PTR
      DOUBLE COMPLEX     ALPHA2
      INTEGER            V2PTR
      DOUBLE COMPLEX     ALPHA3
      INTEGER            V3PTR
      DOUBLE COMPLEX     ALPHA4
      INTEGER            V4PTR

      IF (V1PTR .EQ. 0) THEN
        CALL zspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL zspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL zspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL zspzronotca (V4PTR)
      END IF

      CALL zspg4 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspg5v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR,ALPHA5,V5PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of spg5  ( GAXPY 5 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      REAL               ALPHA1
      INTEGER            V1PTR
      REAL               ALPHA2
      INTEGER            V2PTR
      REAL               ALPHA3
      INTEGER            V3PTR
      REAL               ALPHA4
      INTEGER            V4PTR
      REAL               ALPHA5
      INTEGER            V5PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL sspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL xsprhs (line,file,3)
        CALL sspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL xsprhs (line,file,4)
        CALL sspzronotca (V4PTR)
      END IF
      IF (V5PTR .EQ. 0) THEN
        CALL xsprhs (line,file,5)
        CALL sspzronotca (V5PTR)
      END IF

      CALL sspg5 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR,ALPHA5,V5PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspg5v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR,ALPHA5,V5PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of spg5  ( GAXPY 5 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE PRECISION   ALPHA1
      INTEGER            V1PTR
      DOUBLE PRECISION   ALPHA2
      INTEGER            V2PTR
      DOUBLE PRECISION   ALPHA3
      INTEGER            V3PTR
      DOUBLE PRECISION   ALPHA4
      INTEGER            V4PTR
      DOUBLE PRECISION   ALPHA5
      INTEGER            V5PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL dspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL xsprhs (line,file,3)
        CALL dspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL xsprhs (line,file,4)
        CALL dspzronotca (V4PTR)
      END IF
      IF (V5PTR .EQ. 0) THEN
        CALL xsprhs (line,file,5)
        CALL dspzronotca (V5PTR)
      END IF

      CALL dspg5 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR,ALPHA5,V5PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspg5v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR,ALPHA5,V5PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of spg5  ( GAXPY 5 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      COMPLEX            ALPHA1
      INTEGER            V1PTR
      COMPLEX            ALPHA2
      INTEGER            V2PTR
      COMPLEX            ALPHA3
      INTEGER            V3PTR
      COMPLEX            ALPHA4
      INTEGER            V4PTR
      COMPLEX            ALPHA5
      INTEGER            V5PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL cspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL xsprhs (line,file,3)
        CALL cspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL xsprhs (line,file,4)
        CALL cspzronotca (V4PTR)
      END IF
      IF (V5PTR .EQ. 0) THEN
        CALL xsprhs (line,file,5)
        CALL cspzronotca (V5PTR)
      END IF

      CALL cspg5 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR,ALPHA5,V5PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspg5v (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR,ALPHA5,V5PTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of spg5  ( GAXPY 5 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE COMPLEX     ALPHA1
      INTEGER            V1PTR
      DOUBLE COMPLEX     ALPHA2
      INTEGER            V2PTR
      DOUBLE COMPLEX     ALPHA3
      INTEGER            V3PTR
      DOUBLE COMPLEX     ALPHA4
      INTEGER            V4PTR
      DOUBLE COMPLEX     ALPHA5
      INTEGER            V5PTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (V1PTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL zspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL xsprhs (line,file,3)
        CALL zspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL xsprhs (line,file,4)
        CALL zspzronotca (V4PTR)
      END IF
      IF (V5PTR .EQ. 0) THEN
        CALL xsprhs (line,file,5)
        CALL zspzronotca (V5PTR)
      END IF

      CALL zspg5 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR,ALPHA5,V5PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspg5q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR,ALPHA5,V5PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of spg5  ( GAXPY 5 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      REAL               ALPHA1
      INTEGER            V1PTR
      REAL               ALPHA2
      INTEGER            V2PTR
      REAL               ALPHA3
      INTEGER            V3PTR
      REAL               ALPHA4
      INTEGER            V4PTR
      REAL               ALPHA5
      INTEGER            V5PTR

      IF (V1PTR .EQ. 0) THEN
        CALL sspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL sspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL sspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL sspzronotca (V4PTR)
      END IF
      IF (V5PTR .EQ. 0) THEN
        CALL sspzronotca (V5PTR)
      END IF

      CALL sspg5 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR,ALPHA5,V5PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspg5q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR,ALPHA5,V5PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of spg5  ( GAXPY 5 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE PRECISION   ALPHA1
      INTEGER            V1PTR
      DOUBLE PRECISION   ALPHA2
      INTEGER            V2PTR
      DOUBLE PRECISION   ALPHA3
      INTEGER            V3PTR
      DOUBLE PRECISION   ALPHA4
      INTEGER            V4PTR
      DOUBLE PRECISION   ALPHA5
      INTEGER            V5PTR

      IF (V1PTR .EQ. 0) THEN
        CALL dspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL dspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL dspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL dspzronotca (V4PTR)
      END IF
      IF (V5PTR .EQ. 0) THEN
        CALL dspzronotca (V5PTR)
      END IF

      CALL dspg5 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR,ALPHA5,V5PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspg5q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR,ALPHA5,V5PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of spg5  ( GAXPY 5 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      COMPLEX            ALPHA1
      INTEGER            V1PTR
      COMPLEX            ALPHA2
      INTEGER            V2PTR
      COMPLEX            ALPHA3
      INTEGER            V3PTR
      COMPLEX            ALPHA4
      INTEGER            V4PTR
      COMPLEX            ALPHA5
      INTEGER            V5PTR

      IF (V1PTR .EQ. 0) THEN
        CALL cspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL cspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL cspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL cspzronotca (V4PTR)
      END IF
      IF (V5PTR .EQ. 0) THEN
        CALL cspzronotca (V5PTR)
      END IF

      CALL cspg5 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR,ALPHA5,V5PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspg5q (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,
     +ALPHA4,V4PTR,ALPHA5,V5PTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of spg5  ( GAXPY 5 ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      DOUBLE COMPLEX     ALPHA1
      INTEGER            V1PTR
      DOUBLE COMPLEX     ALPHA2
      INTEGER            V2PTR
      DOUBLE COMPLEX     ALPHA3
      INTEGER            V3PTR
      DOUBLE COMPLEX     ALPHA4
      INTEGER            V4PTR
      DOUBLE COMPLEX     ALPHA5
      INTEGER            V5PTR

      IF (V1PTR .EQ. 0) THEN
        CALL zspzronotca (V1PTR)
      END IF
      IF (V2PTR .EQ. 0) THEN
        CALL zspzronotca (V2PTR)
      END IF
      IF (V3PTR .EQ. 0) THEN
        CALL zspzronotca (V3PTR)
      END IF
      IF (V4PTR .EQ. 0) THEN
        CALL zspzronotca (V4PTR)
      END IF
      IF (V5PTR .EQ. 0) THEN
        CALL zspzronotca (V5PTR)
      END IF

      CALL zspg5 (DESTPTR,ALPHA1,V1PTR,ALPHA2,V2PTR,ALPHA3,V3PTR,ALPHA4,
     +V4PTR,ALPHA5,V5PTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspgxv (DESTPTR,ARITY,ALPHAVEC,VPTRVEC,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of spgx  ( GAXPY X ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            ARITY
      REAL               ALPHAVEC (ARITY)
      INTEGER            VPTRVEC (ARITY)
      INTEGER            line
      CHARACTER*(*)      file

      DO 100 i = 1, ARITY
        IF (VPTRVEC(i) .EQ. 0) THEN
          CALL xsprhs (line,file,i)
          CALL sspzronotca (VPTRVEC(i))
        END IF
 100  CONTINUE

      CALL sspgx (DESTPTR,ARITY,ALPHAVEC,VPTRVEC)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspgxv (DESTPTR,ARITY,ALPHAVEC,VPTRVEC,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of spgx  ( GAXPY X ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            ARITY
      DOUBLE PRECISION   ALPHAVEC (ARITY)
      INTEGER            VPTRVEC (ARITY)
      INTEGER            line
      CHARACTER*(*)      file

      DO 100 i = 1, ARITY
        IF (VPTRVEC(i) .EQ. 0) THEN
          CALL xsprhs (line,file,i)
          CALL dspzronotca (VPTRVEC(i))
        END IF
 100  CONTINUE

      CALL dspgx (DESTPTR,ARITY,ALPHAVEC,VPTRVEC)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspgxv (DESTPTR,ARITY,ALPHAVEC,VPTRVEC,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of spgx  ( GAXPY X ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            ARITY
      COMPLEX            ALPHAVEC (ARITY)
      INTEGER            VPTRVEC (ARITY)
      INTEGER            line
      CHARACTER*(*)      file

      DO 100 i = 1, ARITY
        IF (VPTRVEC(i) .EQ. 0) THEN
          CALL xsprhs (line,file,i)
          CALL cspzronotca (VPTRVEC(i))
        END IF
 100  CONTINUE

      CALL cspgx (DESTPTR,ARITY,ALPHAVEC,VPTRVEC)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspgxv (DESTPTR,ARITY,ALPHAVEC,VPTRVEC,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of spgx  ( GAXPY X ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            ARITY
      DOUBLE COMPLEX     ALPHAVEC (ARITY)
      INTEGER            VPTRVEC (ARITY)
      INTEGER            line
      CHARACTER*(*)      file

      DO 100 i = 1, ARITY
        IF (VPTRVEC(i) .EQ. 0) THEN
          CALL xsprhs (line,file,i)
          CALL zspzronotca (VPTRVEC(i))
        END IF
 100  CONTINUE

      CALL zspgx (DESTPTR,ARITY,ALPHAVEC,VPTRVEC)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE sspgxq (DESTPTR,ARITY,ALPHAVEC,VPTRVEC)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of spgx  ( GAXPY X ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            ARITY
      REAL               ALPHAVEC (ARITY)
      INTEGER            VPTRVEC (ARITY)

      DO 100 i = 1, ARITY
        IF (VPTRVEC(i) .EQ. 0) THEN
          CALL sspzronotca (VPTRVEC(i))
        END IF
 100  CONTINUE

      CALL sspgx (DESTPTR,ARITY,ALPHAVEC,VPTRVEC)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dspgxq (DESTPTR,ARITY,ALPHAVEC,VPTRVEC)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of spgx  ( GAXPY X ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            ARITY
      DOUBLE PRECISION   ALPHAVEC (ARITY)
      INTEGER            VPTRVEC (ARITY)

      DO 100 i = 1, ARITY
        IF (VPTRVEC(i) .EQ. 0) THEN
          CALL dspzronotca (VPTRVEC(i))
        END IF
 100  CONTINUE

      CALL dspgx (DESTPTR,ARITY,ALPHAVEC,VPTRVEC)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspgxq (DESTPTR,ARITY,ALPHAVEC,VPTRVEC)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of spgx  ( GAXPY X ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            ARITY
      COMPLEX            ALPHAVEC (ARITY)
      INTEGER            VPTRVEC (ARITY)

      DO 100 i = 1, ARITY
        IF (VPTRVEC(i) .EQ. 0) THEN
          CALL cspzronotca (VPTRVEC(i))
        END IF
 100  CONTINUE

      CALL cspgx (DESTPTR,ARITY,ALPHAVEC,VPTRVEC)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspgxq (DESTPTR,ARITY,ALPHAVEC,VPTRVEC)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of spgx  ( GAXPY X ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            ARITY
      DOUBLE COMPLEX     ALPHAVEC (ARITY)
      INTEGER            VPTRVEC (ARITY)

      DO 100 i = 1, ARITY
        IF (VPTRVEC(i) .EQ. 0) THEN
          CALL zspzronotca (VPTRVEC(i))
        END IF
 100  CONTINUE

      CALL zspgx (DESTPTR,ARITY,ALPHAVEC,VPTRVEC)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspimv (DESTPTR,VPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of spim  ( IMAG    ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (VPTR)
      END IF

      CALL cspim (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspimv (DESTPTR,VPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of spim  ( IMAG    ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (VPTR)
      END IF

      CALL zspim (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspimq (DESTPTR,VPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of spim  ( IMAG    ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR

      IF (VPTR .EQ. 0) THEN
        CALL cspzronotca (VPTR)
      END IF

      CALL cspim (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspimq (DESTPTR,VPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of spim  ( IMAG    ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR

      IF (VPTR .EQ. 0) THEN
        CALL zspzronotca (VPTR)
      END IF

      CALL zspim (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspcjv (DESTPTR,VPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of spcj  (CONJUGATE).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (VPTR)
      END IF

      CALL cspcj (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspcjv (DESTPTR,VPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of spcj  (CONJUGATE).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (VPTR)
      END IF

      CALL zspcj (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE cspcjq (DESTPTR,VPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of spcj  (CONJUGATE).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR

      IF (VPTR .EQ. 0) THEN
        CALL cspzronotca (VPTR)
      END IF

      CALL cspcj (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zspcjq (DESTPTR,VPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of spcj  (CONJUGATE).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR

      IF (VPTR .EQ. 0) THEN
        CALL zspzronotca (VPTR)
      END IF

      CALL zspcj (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE ssp2sv (DESTPTR,VPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of sp2s  ( CONV2S  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (VPTR)
      END IF

      CALL ssp2s (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dsp2sv (DESTPTR,VPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of sp2s  ( CONV2S  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (VPTR)
      END IF

      CALL dsp2s (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE csp2sv (DESTPTR,VPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of sp2s  ( CONV2S  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (VPTR)
      END IF

      CALL csp2s (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zsp2sv (DESTPTR,VPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of sp2s  ( CONV2S  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (VPTR)
      END IF

      CALL zsp2s (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE ssp2sq (DESTPTR,VPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of sp2s  ( CONV2S  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR

      IF (VPTR .EQ. 0) THEN
        CALL sspzronotca (VPTR)
      END IF

      CALL ssp2s (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dsp2sq (DESTPTR,VPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of sp2s  ( CONV2S  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR

      IF (VPTR .EQ. 0) THEN
        CALL dspzronotca (VPTR)
      END IF

      CALL dsp2s (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE csp2sq (DESTPTR,VPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of sp2s  ( CONV2S  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR

      IF (VPTR .EQ. 0) THEN
        CALL cspzronotca (VPTR)
      END IF

      CALL csp2s (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zsp2sq (DESTPTR,VPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of sp2s  ( CONV2S  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR

      IF (VPTR .EQ. 0) THEN
        CALL zspzronotca (VPTR)
      END IF

      CALL zsp2s (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE ssp2dv (DESTPTR,VPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of sp2d  ( CONV2D  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (VPTR)
      END IF

      CALL ssp2d (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dsp2dv (DESTPTR,VPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of sp2d  ( CONV2D  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (VPTR)
      END IF

      CALL dsp2d (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE csp2dv (DESTPTR,VPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       COMPLEX          version of sp2d  ( CONV2D  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL cspzronotca (VPTR)
      END IF

      CALL csp2d (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zsp2dv (DESTPTR,VPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE COMPLEX   version of sp2d  ( CONV2D  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL zspzronotca (VPTR)
      END IF

      CALL zsp2d (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE ssp2dq (DESTPTR,VPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of sp2d  ( CONV2D  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR

      IF (VPTR .EQ. 0) THEN
        CALL sspzronotca (VPTR)
      END IF

      CALL ssp2d (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dsp2dq (DESTPTR,VPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of sp2d  ( CONV2D  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR

      IF (VPTR .EQ. 0) THEN
        CALL dspzronotca (VPTR)
      END IF

      CALL dsp2d (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE csp2dq (DESTPTR,VPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       COMPLEX          version of sp2d  ( CONV2D  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR

      IF (VPTR .EQ. 0) THEN
        CALL cspzronotca (VPTR)
      END IF

      CALL csp2d (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE zsp2dq (DESTPTR,VPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE COMPLEX   version of sp2d  ( CONV2D  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VPTR

      IF (VPTR .EQ. 0) THEN
        CALL zspzronotca (VPTR)
      END IF

      CALL zsp2d (DESTPTR,VPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE ssp2cv (DESTPTR,VRLPTR,VIMPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of sp2c  ( CONV2C  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VRLPTR
      INTEGER            VIMPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VRLPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (VRLPTR)
      END IF
      IF (VIMPTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL sspzronotca (VIMPTR)
      END IF

      CALL ssp2c (DESTPTR,VRLPTR,VIMPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dsp2cv (DESTPTR,VRLPTR,VIMPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of sp2c  ( CONV2C  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VRLPTR
      INTEGER            VIMPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VRLPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (VRLPTR)
      END IF
      IF (VIMPTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL dspzronotca (VIMPTR)
      END IF

      CALL dsp2c (DESTPTR,VRLPTR,VIMPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE ssp2cq (DESTPTR,VRLPTR,VIMPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of sp2c  ( CONV2C  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VRLPTR
      INTEGER            VIMPTR

      IF (VRLPTR .EQ. 0) THEN
        CALL sspzronotca (VRLPTR)
      END IF
      IF (VIMPTR .EQ. 0) THEN
        CALL sspzronotca (VIMPTR)
      END IF

      CALL ssp2c (DESTPTR,VRLPTR,VIMPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dsp2cq (DESTPTR,VRLPTR,VIMPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of sp2c  ( CONV2C  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VRLPTR
      INTEGER            VIMPTR

      IF (VRLPTR .EQ. 0) THEN
        CALL dspzronotca (VRLPTR)
      END IF
      IF (VIMPTR .EQ. 0) THEN
        CALL dspzronotca (VIMPTR)
      END IF

      CALL dsp2c (DESTPTR,VRLPTR,VIMPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE ssp2zv (DESTPTR,VRLPTR,VIMPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       REAL             version of sp2z  ( CONV2Z  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VRLPTR
      INTEGER            VIMPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VRLPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL sspzronotca (VRLPTR)
      END IF
      IF (VIMPTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL sspzronotca (VIMPTR)
      END IF

      CALL ssp2z (DESTPTR,VRLPTR,VIMPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dsp2zv (DESTPTR,VRLPTR,VIMPTR,line,file)
C                                                                        *
C	PERL-generated FORTRAN source code for the verbose,              *
C       DOUBLE PRECISION version of sp2z  ( CONV2Z  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VRLPTR
      INTEGER            VIMPTR
      INTEGER            line
      CHARACTER*(*)      file

      IF (VRLPTR .EQ. 0) THEN
        CALL xsprhs (line,file,1)
        CALL dspzronotca (VRLPTR)
      END IF
      IF (VIMPTR .EQ. 0) THEN
        CALL xsprhs (line,file,2)
        CALL dspzronotca (VIMPTR)
      END IF

      CALL dsp2z (DESTPTR,VRLPTR,VIMPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE ssp2zq (DESTPTR,VRLPTR,VIMPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       REAL             version of sp2z  ( CONV2Z  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VRLPTR
      INTEGER            VIMPTR

      IF (VRLPTR .EQ. 0) THEN
        CALL sspzronotca (VRLPTR)
      END IF
      IF (VIMPTR .EQ. 0) THEN
        CALL sspzronotca (VIMPTR)
      END IF

      CALL ssp2z (DESTPTR,VRLPTR,VIMPTR)

      RETURN
      END


C*************************************************************************
C                                                                        *
      SUBROUTINE dsp2zq (DESTPTR,VRLPTR,VIMPTR)
C                                                                        *
C	PERL-generated FORTRAN source code for the quiet,                *
C       DOUBLE PRECISION version of sp2z  ( CONV2Z  ).                   *
C                                                                        *
C*************************************************************************

      INTEGER            DESTPTR
      INTEGER            VRLPTR
      INTEGER            VIMPTR

      IF (VRLPTR .EQ. 0) THEN
        CALL dspzronotca (VRLPTR)
      END IF
      IF (VIMPTR .EQ. 0) THEN
        CALL dspzronotca (VIMPTR)
      END IF

      CALL dsp2z (DESTPTR,VRLPTR,VIMPTR)

      RETURN
      END


