      program admain
C     main program for computation of full dense Jacobian for c2 example

      integer MMAX,G_PMAX_,m,i,j
      parameter (MMAX = 20, G_PMAX_ = 20)
C     Warning: Values of MMAX > 999 will break the format statements

      double precision x, y(MMAX), yp(MMAX)
      double precision g_y(G_PMAX_,MMAX), g_yp(G_PMAX_,MMAX)
      character*20 fmtstring

C     read in input values for m, x and y
      write(*,'(a,i3)') 'Enter 1 <= m <= ',MMAX
      read (*,*) m
      write(*,*) 'Enter x:'
      read (*,*) x
      write(*,*) 'Enter y(1), ..., y(m):'
      read (*,*) (y(j), j = 1, m)

C     initialize gradient object for the independent variable
C     to the m x m identity matrix (seed matrix g_y = I)
      do j = 1, m
         do i = 1, m
            g_y(i,j) = 0.0
         enddo
         g_y(j,j) = 1.0
      enddo

      call g_fcn2(m, m, x, y, g_y, G_PMAX_, yp, g_yp, G_PMAX_)

      call ehrpt

      write(fmtstring,1000) m
 1000 format('(',i4,'(e10.3))') 

      write(*,'(/,a)') 'Computed values for yp(1), ..., yp(m):'
      write(*,fmtstring) (yp(j), j = 1, m)

      write(*,'(/,a)') 'Derivatives of yp(:) with respect to y(:).'
      write(*,*) 'Entry (i,j) in the following matrix is the'
      write(*,*) 'derivative of yp(i) with respect to y(j):'
C     print out TRANSPOSE of g_yp
      do 30 j = 1, m
         write (*, fmtstring) (g_yp(i, j), i = 1, m)
 30   continue

      end
