C     File:  FCN.f

      SUBROUTINE FCN(N,X,Y,YP)

C     ROUTINE TO EVALUATE THE DERIVATIVE F(X,Y) CORRESPONDING
C     TO THE DIFFERENTIAL EQUATION:
C                    DY/DX = F(X,Y) .
C     THE ROUTINE STORES THE VECTOR OF DERIVATIVES IN YP(*). 

      INTEGER N
      DOUBLE PRECISION X, Y(N), YP(N)

      INTEGER        ID
      COMMON         /STCOM5/ ID

      DOUBLE PRECISION SUM, CPARM(4)
      INTEGER        I, IID
      DATA           CPARM/1.D-1, 1.D0, 1.D1, 2.D1/

      IID = MOD(ID,10)
      IF ((IID .LT. 2) .OR. (IID .GT. 5)) THEN 
         WRITE(*,*) 'Invalid Value for ID'
         STOP
      ENDIF

      YP(1) = -Y(1) + 2.D0
      SUM = Y(1)*Y(1)
      DO 50 I = 2, N
         YP(I) = -10.0D0*I*Y(I) + CPARM(IID-1)*(2**I)*SUM
         SUM = SQRT(SUM**2 + Y(I)*Y(I))
   50 CONTINUE

      RETURN
      END
