      program admain
C     main program for computation of selected columns of the
C     Jacobian for c2 example

      integer MMAX,G_PMAX_,m,i,j,no_derivs
      parameter (MMAX = 20, G_PMAX_ = 3)
C     Warning: Values of MMAX > 999 will break the format statements

      double precision x, y(MMAX), yp(MMAX)
      double precision g_y(G_PMAX_,MMAX), g_yp(G_PMAX_,MMAX)
      integer deriv_index(G_PMAX_)
      character*20 fmtstring

C     read in input values for m, x and y
      write(*,'(a,i3)') 'Enter 7 <= m <= ',MMAX
      read (*,*) m
      write(*,*) 'Enter x:'
      read (*,*) x
      write(*,*) 'Enter y(1), ..., y(m):'
      read (*,*) (y(j), j = 1, m)

C     compute columns 3, 4, 7 of Jacobian, i.e., three derivatives.

      no_derivs = 3
      deriv_index(1) = 3
      deriv_index(2) = 4
      deriv_index(3) = 7

      do j = 1, m
         do i = 1, no_derivs
            g_y(i,j) = 0.0
         enddo
      enddo
      do i = 1, no_derivs
         g_y(i,deriv_index(i)) = 1.0
      enddo

      call g_fcn2(no_derivs, m, x, y, g_y, G_PMAX_, yp, g_yp, G_PMAX_)

      call ehrpt

      write(fmtstring,1000) m
      write(*,'(/,a)') 'Computed values for yp(1), ..., yp(m):'
      write(*,fmtstring) (yp(j), j = 1, m)

      write(*,*) 'selected derivatives of yp(1:m) with respect to y:'
      write(*,*) 'Entry (i,j) in the following matrix is the',
     $     'derivative of yp(i) with respect to y(deriv_index(j))'

C     print out TRANSPOSE of g_yp(1:chunksize,1:m)
      write(fmtstring,1000) no_derivs
      do j = 1, m
         write (*, fmtstring) (g_yp(i, j), i = 1, no_derivs)
      enddo
      
 1000 format('(',i4,'(e10.3))') 
      end
