      program admain
C     main program for computation of full dense Jacobian for c2 example

      integer MMAX,m,i,j
      parameter (MMAX = 20)
C     Warning: Values of MMAX > 999 will break the format statements

      double precision x, y(MMAX), yp(MMAX)
      integer g_y(MMAX), g_yp(MMAX)
C     Making these arrays static should force them to be set to 0
      save g_y, g_yp

      character*20 fmtstring
      double precision valvec(1)
      integer indvec(1)
      integer outlen, info
      double precision ypvec(MMAX)
      double precision yvec(MMAX)

C     read in input values for m, x and y
      write(*,'(a,i3)') 'Enter 1 <= m <= ',MMAX
      read (*,*) m
      write(*,*) 'Enter x:'
      read (*,*) x
      write(*,*) 'Enter y(1), ..., y(m):'
      read (*,*) (y(j), j = 1, m)

C     prepare for I/O
      write(fmtstring,1000) m
 1000 format('(',i4,'(e10.3))') 

      call xspini

C     initialize gradient object for the independent variable
C     to the m x m identity matrix (seed matrix g_y = I)

      valvec(1) = 1.0d0
      do j = 1, m
         indvec(1) = j
         call dspsd(g_y(j), indvec, valvec, 1)
      enddo

      call g_fcn2(m, x, y, g_y, yp, g_yp)

      call ehrpt

      write(*,'(/,a)') 'Computed values for yp(1), ..., yp(m):'
      write(*,fmtstring) (yp(j), j = 1, m)

      write(*,'(/,a)') 'Derivatives of yp(:) with respect to y(:).'
      write(*,*) 'Entry (i,j) in the following matrix is the'
      write(*,*) 'derivative of yp(i) with respect to y(j):'
C     print out TRANSPOSE of g_yp

      do j = 1, m
         call dspxdq(ypvec, m, g_yp(j), outlen, info)
         write (*, fmtstring) (ypvec(i), i = 1, m)
      enddo

      call xspfra

      end
