      program admain
C     main program for computation of stripmined Jacobian for c2 example

      integer MMAX,G_PMAX_,m,i,j,k,chunksize
      parameter (MMAX = 20, G_PMAX_ = 5)
C     Warning: Values of MMAX > 999 will break the format statements

      double precision x, y(MMAX), yp(MMAX)
      double precision g_y(G_PMAX_,MMAX), g_yp(G_PMAX_,MMAX)
      character*20 fmtstring

C     size of a derivative slice. 1 <= SLICE <= G_PMAX_ is acceptable,
C     but SLICE = G_PMAX_ is most efficient.
      integer SLICE
      parameter (SLICE = G_PMAX_)

C     read in input values for m, x and y
      write(*,'(a,i3)') 'Enter 1 <= m <= ',MMAX
      read (*,*) m
      write(*,*) 'Enter x:'
      read (*,*) x
      write(*,*) 'Enter y(1), ..., y(m):'
      read (*,*) (y(j), j = 1, m)

      do 50 k = 1,m,SLICE

C     compute columns k, ... ,min(m,k+SLICE) of Jacobian.

         chunksize = min(SLICE,m-k+1)

C     initialize g_y(1:chunksize,k:k+chunksize-1) to the identity
C     and all other entries of g_y(1:chunksize,1:m) to zero.

         do j = 1, m
            do i = 1, chunksize
               g_y(i,j) = 0.0
            enddo
         enddo
         do i = 1, chunksize
            g_y(i,k+i-1) = 1.0
         enddo

         call g_fcn2(chunksize, m, x, y, g_y, G_PMAX_, 
     $               yp, g_yp, G_PMAX_)

         call ehrpt

C     Print values for yp only after the first chunk. These values will be
C     recomputed every time through the "k" loop.

         if (k .eq. 1) then
            write(fmtstring,1000) m
            write(*,'(/,a)') 'Computed values for yp(1), ..., yp(m):'
            write(*,fmtstring) (yp(j), j = 1, m)
         endif

         write(*,'(/,a,a,i3,a,i3,a)') 'Derivatives of yp(1:m) with ',
     $        'respect to y(', k,':',k+chunksize-1,')'
         write(*,'(a,a,/,a,i3,a)') 'Entry (i,j) in the following ',
     $        'matrix is the','derivative of yp(i) with respect to y(',
     $                 k-1,'+j):'

C     print out TRANSPOSE of g_yp(1:chunksize,1:m)
         write(fmtstring,1000) chunksize
         do j = 1, m
            write (*, fmtstring) (g_yp(i, j), i = 1, chunksize)
         enddo

 50   continue
     
 1000 format('(',i4,'(e10.3))') 
      end
