      program admain
C     main program for computation Jacobian*vector product for c2 example

      integer MMAX,G_PMAX_,m,j
      parameter (MMAX = 20, G_PMAX_ = 1)
C     Warning: Values of MMAX > 999 will break the format statements

      double precision x, y(MMAX), yp(MMAX), v(MMAX)
      double precision g_y(G_PMAX_,MMAX), g_yp(G_PMAX_,MMAX)
      character*20 fmtstring

C     read in input values for m, x and y
      write(*,'(a,i3)') 'Enter 1 <= m <= ',MMAX
      read (*,*) m
      write(*,*) 'Enter x:'
      read (*,*) x
      write(*,*) 'Enter y(1), ..., y(m):'
      read (*,*) (y(j), j = 1, m)
      write(*,*) 'Enter v(1), ..., v(m):'
      read (*,*) (v(j), j = 1, m)

C     initialize g_y = v. This can be interpreted as saying that 
C     derivative computed in g_y(1,:) contains a contribution of the
C     j-th column of d yp/ d y weighted by v(j).

      do j = 1, m
         g_y(1,j) = v(j)
      enddo

      call g_fcn2(1, m, x, y, g_y, G_PMAX_, yp, g_yp, G_PMAX_)

      call ehrpt

      write(fmtstring,1000) m
      write(*,'(/,a)') 'Computed values for yp(1), ..., yp(m):'
      write(*,fmtstring) (yp(j), j = 1, m)

      write(*,'(/,a)') 'Matrix-vector product d yp/ dy * v:'
      write (*, fmtstring) (g_yp(1, j), j = 1, m)
      
 1000 format('(',i4,'(e10.3))')
      end
